/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.0.466
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ApplicationControlRule = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The ApplicationControlRule model module.
   * @module model/ApplicationControlRule
   * @version 12.0.466
   */

  /**
   * Constructs a new <code>ApplicationControlRule</code>.
   * Ruleset rule details.
   * @alias module:model/ApplicationControlRule
   * @class
   */
  var exports = function() {
    var _this = this;









  };

  /**
   * Constructs a <code>ApplicationControlRule</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ApplicationControlRule} obj Optional instance to populate.
   * @return {module:model/ApplicationControlRule} The populated <code>ApplicationControlRule</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('sha256')) {
        obj['sha256'] = ApiClient.convertToType(data['sha256'], 'String');
      }
      if (data.hasOwnProperty('size')) {
        obj['size'] = ApiClient.convertToType(data['size'], 'Number');
      }
      if (data.hasOwnProperty('action')) {
        obj['action'] = ApiClient.convertToType(data['action'], 'String');
      }
      if (data.hasOwnProperty('path')) {
        obj['path'] = ApiClient.convertToType(data['path'], 'String');
      }
      if (data.hasOwnProperty('fileName')) {
        obj['fileName'] = ApiClient.convertToType(data['fileName'], 'String');
      }
      if (data.hasOwnProperty('lastUpdatedAdministrator')) {
        obj['lastUpdatedAdministrator'] = ApiClient.convertToType(data['lastUpdatedAdministrator'], 'Number');
      }
      if (data.hasOwnProperty('lastUpdated')) {
        obj['lastUpdated'] = ApiClient.convertToType(data['lastUpdated'], 'Number');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * SHA-256 hash of the executable. Searchable as String.
   * @member {String} sha256
   */
  exports.prototype['sha256'] = undefined;
  /**
   * Size of the executable in bytes. Searchable as Numeric.
   * @member {Number} size
   */
  exports.prototype['size'] = undefined;
  /**
   * Action to take when a user launches the executable. Searchable as Choice.
   * @member {module:model/ApplicationControlRule.ActionEnum} action
   */
  exports.prototype['action'] = undefined;
  /**
   * Full path of the executable. Searchable as String.
   * @member {String} path
   */
  exports.prototype['path'] = undefined;
  /**
   * File name of the executable.
   * @member {String} fileName
   */
  exports.prototype['fileName'] = undefined;
  /**
   * ID of the last administrator to update the rule. Searchable as Numeric.
   * @member {Number} lastUpdatedAdministrator
   */
  exports.prototype['lastUpdatedAdministrator'] = undefined;
  /**
   * Timestamp of the last rule modification, in milliseconds since epoch. Searchable as Date.
   * @member {Number} lastUpdated
   */
  exports.prototype['lastUpdated'] = undefined;
  /**
   * ID of the rule. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;


  /**
   * Allowed values for the <code>action</code> property.
   * @enum {String}
   * @readonly
   */
  exports.ActionEnum = {
    /**
     * value: "allow"
     * @const
     */
    "allow": "allow",
    /**
     * value: "block"
     * @const
     */
    "block": "block"  };


  return exports;
}));



