/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.0.466
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ComputerRights = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The ComputerRights model module.
   * @module model/ComputerRights
   * @version 12.0.466
   */

  /**
   * Constructs a new <code>ComputerRights</code>.
   * Computer right details.
   * @alias module:model/ComputerRights
   * @class
   */
  var exports = function() {
    var _this = this;













  };

  /**
   * Constructs a <code>ComputerRights</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ComputerRights} obj Optional instance to populate.
   * @return {module:model/ComputerRights} The populated <code>ComputerRights</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('canAddAndRemoveComputerGroups')) {
        obj['canAddAndRemoveComputerGroups'] = ApiClient.convertToType(data['canAddAndRemoveComputerGroups'], 'Boolean');
      }
      if (data.hasOwnProperty('canCreateNewComputers')) {
        obj['canCreateNewComputers'] = ApiClient.convertToType(data['canCreateNewComputers'], 'Boolean');
      }
      if (data.hasOwnProperty('canDeleteComputers')) {
        obj['canDeleteComputers'] = ApiClient.convertToType(data['canDeleteComputers'], 'Boolean');
      }
      if (data.hasOwnProperty('canDismissAlerts')) {
        obj['canDismissAlerts'] = ApiClient.convertToType(data['canDismissAlerts'], 'Boolean');
      }
      if (data.hasOwnProperty('canEditComputerProperties')) {
        obj['canEditComputerProperties'] = ApiClient.convertToType(data['canEditComputerProperties'], 'Boolean');
      }
      if (data.hasOwnProperty('canImportComputers')) {
        obj['canImportComputers'] = ApiClient.convertToType(data['canImportComputers'], 'Boolean');
      }
      if (data.hasOwnProperty('canManageCloudAccounts')) {
        obj['canManageCloudAccounts'] = ApiClient.convertToType(data['canManageCloudAccounts'], 'Boolean');
      }
      if (data.hasOwnProperty('canManageDirectories')) {
        obj['canManageDirectories'] = ApiClient.convertToType(data['canManageDirectories'], 'Boolean');
      }
      if (data.hasOwnProperty('canManageVCenters')) {
        obj['canManageVCenters'] = ApiClient.convertToType(data['canManageVCenters'], 'Boolean');
      }
      if (data.hasOwnProperty('canTagComputers')) {
        obj['canTagComputers'] = ApiClient.convertToType(data['canTagComputers'], 'Boolean');
      }
      if (data.hasOwnProperty('canViewNotRelatedToComputers')) {
        obj['canViewNotRelatedToComputers'] = ApiClient.convertToType(data['canViewNotRelatedToComputers'], 'Boolean');
      }
      if (data.hasOwnProperty('canViewOtherComputers')) {
        obj['canViewOtherComputers'] = ApiClient.convertToType(data['canViewOtherComputers'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * Right to add and remove computer groups.
   * @member {Boolean} canAddAndRemoveComputerGroups
   */
  exports.prototype['canAddAndRemoveComputerGroups'] = undefined;
  /**
   * Right to create new computers.
   * @member {Boolean} canCreateNewComputers
   */
  exports.prototype['canCreateNewComputers'] = undefined;
  /**
   * Right to delete computers.
   * @member {Boolean} canDeleteComputers
   */
  exports.prototype['canDeleteComputers'] = undefined;
  /**
   * Right to dismiss computer alerts.
   * @member {Boolean} canDismissAlerts
   */
  exports.prototype['canDismissAlerts'] = undefined;
  /**
   * Right to edit computer properties.
   * @member {Boolean} canEditComputerProperties
   */
  exports.prototype['canEditComputerProperties'] = undefined;
  /**
   * Right to import computers.
   * @member {Boolean} canImportComputers
   */
  exports.prototype['canImportComputers'] = undefined;
  /**
   * Right to manage cloud accounts.
   * @member {Boolean} canManageCloudAccounts
   */
  exports.prototype['canManageCloudAccounts'] = undefined;
  /**
   * Right to manage directories.
   * @member {Boolean} canManageDirectories
   */
  exports.prototype['canManageDirectories'] = undefined;
  /**
   * Right to manage VMware vCenters.
   * @member {Boolean} canManageVCenters
   */
  exports.prototype['canManageVCenters'] = undefined;
  /**
   * Right to tag computers.
   * @member {Boolean} canTagComputers
   */
  exports.prototype['canTagComputers'] = undefined;
  /**
   * Right to view events and alerts not related to computers.
   * @member {Boolean} canViewNotRelatedToComputers
   */
  exports.prototype['canViewNotRelatedToComputers'] = undefined;
  /**
   * Right to view non-selected computers.
   * @member {Boolean} canViewOtherComputers
   */
  exports.prototype['canViewOtherComputers'] = undefined;



  return exports;
}));



