/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.0.466
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CustomAttribute'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CustomAttribute'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ESXSummary = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.CustomAttribute);
  }
}(this, function(ApiClient, CustomAttribute) {
  'use strict';




  /**
   * The ESXSummary model module.
   * @module model/ESXSummary
   * @version 12.0.466
   */

  /**
   * Constructs a new <code>ESXSummary</code>.
   * VMware ESX Host Information.
   * @alias module:model/ESXSummary
   * @class
   */
  var exports = function() {
    var _this = this;














  };

  /**
   * Constructs a <code>ESXSummary</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ESXSummary} obj Optional instance to populate.
   * @return {module:model/ESXSummary} The populated <code>ESXSummary</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('manufacturer')) {
        obj['manufacturer'] = ApiClient.convertToType(data['manufacturer'], 'String');
      }
      if (data.hasOwnProperty('model')) {
        obj['model'] = ApiClient.convertToType(data['model'], 'String');
      }
      if (data.hasOwnProperty('processors')) {
        obj['processors'] = ApiClient.convertToType(data['processors'], 'String');
      }
      if (data.hasOwnProperty('processorType')) {
        obj['processorType'] = ApiClient.convertToType(data['processorType'], 'String');
      }
      if (data.hasOwnProperty('numberOfNICs')) {
        obj['numberOfNICs'] = ApiClient.convertToType(data['numberOfNICs'], 'String');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
      if (data.hasOwnProperty('virtualMachines')) {
        obj['virtualMachines'] = ApiClient.convertToType(data['virtualMachines'], 'String');
      }
      if (data.hasOwnProperty('vMotionEnabled')) {
        obj['vMotionEnabled'] = ApiClient.convertToType(data['vMotionEnabled'], 'String');
      }
      if (data.hasOwnProperty('customAttributes')) {
        obj['customAttributes'] = ApiClient.convertToType(data['customAttributes'], [CustomAttribute]);
      }
      if (data.hasOwnProperty('TPMEnabled')) {
        obj['TPMEnabled'] = ApiClient.convertToType(data['TPMEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('TPMAlertsEnabled')) {
        obj['TPMAlertsEnabled'] = ApiClient.convertToType(data['TPMAlertsEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('TPMHasData')) {
        obj['TPMHasData'] = ApiClient.convertToType(data['TPMHasData'], 'Boolean');
      }
      if (data.hasOwnProperty('TPMLastChecked')) {
        obj['TPMLastChecked'] = ApiClient.convertToType(data['TPMLastChecked'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Manufacturer of the ESX. Searchable as String.
   * @member {String} manufacturer
   */
  exports.prototype['manufacturer'] = undefined;
  /**
   * Model of the ESX. Searchable as String.
   * @member {String} model
   */
  exports.prototype['model'] = undefined;
  /**
   * Quantity and processor speed of the ESX's processors. Searchable as Numeric.
   * @member {String} processors
   */
  exports.prototype['processors'] = undefined;
  /**
   * Detailed information on the make and model of the ESX's processor. Searchable as String.
   * @member {String} processorType
   */
  exports.prototype['processorType'] = undefined;
  /**
   * Number of Network interface controllers the ESX has. Searchable as Numeric.
   * @member {String} numberOfNICs
   */
  exports.prototype['numberOfNICs'] = undefined;
  /**
   * State of the ESX.
   * @member {String} state
   */
  exports.prototype['state'] = undefined;
  /**
   * Number of virtual machines hosted on the ESX.
   * @member {String} virtualMachines
   */
  exports.prototype['virtualMachines'] = undefined;
  /**
   * Indicates whether vMotion is enabled on the ESX. The is value is true if enabled.
   * @member {String} vMotionEnabled
   */
  exports.prototype['vMotionEnabled'] = undefined;
  /**
   * List of name/value pairs of ESX Custom Attributes
   * @member {Array.<module:model/CustomAttribute>} customAttributes
   */
  exports.prototype['customAttributes'] = undefined;
  /**
   * @member {Boolean} TPMEnabled
   */
  exports.prototype['TPMEnabled'] = undefined;
  /**
   * @member {Boolean} TPMAlertsEnabled
   */
  exports.prototype['TPMAlertsEnabled'] = undefined;
  /**
   * @member {Boolean} TPMHasData
   */
  exports.prototype['TPMHasData'] = undefined;
  /**
   * @member {Number} TPMLastChecked
   */
  exports.prototype['TPMLastChecked'] = undefined;



  return exports;
}));



