/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.0.466
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.MonthlyScheduleParameters = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The MonthlyScheduleParameters model module.
   * @module model/MonthlyScheduleParameters
   * @version 12.0.466
   */

  /**
   * Constructs a new <code>MonthlyScheduleParameters</code>.
   * Details for a monthly schedule for a scheduled task.
   * @alias module:model/MonthlyScheduleParameters
   * @class
   */
  var exports = function() {
    var _this = this;







  };

  /**
   * Constructs a <code>MonthlyScheduleParameters</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/MonthlyScheduleParameters} obj Optional instance to populate.
   * @return {module:model/MonthlyScheduleParameters} The populated <code>MonthlyScheduleParameters</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('startTime')) {
        obj['startTime'] = ApiClient.convertToType(data['startTime'], 'Number');
      }
      if (data.hasOwnProperty('frequencyType')) {
        obj['frequencyType'] = ApiClient.convertToType(data['frequencyType'], 'String');
      }
      if (data.hasOwnProperty('dayOfMonth')) {
        obj['dayOfMonth'] = ApiClient.convertToType(data['dayOfMonth'], 'Number');
      }
      if (data.hasOwnProperty('weekOfMonth')) {
        obj['weekOfMonth'] = ApiClient.convertToType(data['weekOfMonth'], 'String');
      }
      if (data.hasOwnProperty('dayOfWeek')) {
        obj['dayOfWeek'] = ApiClient.convertToType(data['dayOfWeek'], 'String');
      }
      if (data.hasOwnProperty('months')) {
        obj['months'] = ApiClient.convertToType(data['months'], ['String']);
      }
    }
    return obj;
  }

  /**
   * Date/Time when the task should run.
   * @member {Number} startTime
   */
  exports.prototype['startTime'] = undefined;
  /**
   * Frequency type.
   * @member {module:model/MonthlyScheduleParameters.FrequencyTypeEnum} frequencyType
   */
  exports.prototype['frequencyType'] = undefined;
  /**
   * Specific day of month for frequency type: day-of-month.
   * @member {Number} dayOfMonth
   */
  exports.prototype['dayOfMonth'] = undefined;
  /**
   * Specific week of month for frequency type: custom.
   * @member {module:model/MonthlyScheduleParameters.WeekOfMonthEnum} weekOfMonth
   */
  exports.prototype['weekOfMonth'] = undefined;
  /**
   * Specific day of week for frequency type: custom.
   * @member {module:model/MonthlyScheduleParameters.DayOfWeekEnum} dayOfWeek
   */
  exports.prototype['dayOfWeek'] = undefined;
  /**
   * Months of the year when the scheduled task will run.
   * @member {Array.<module:model/MonthlyScheduleParameters.MonthsEnum>} months
   */
  exports.prototype['months'] = undefined;


  /**
   * Allowed values for the <code>frequencyType</code> property.
   * @enum {String}
   * @readonly
   */
  exports.FrequencyTypeEnum = {
    /**
     * value: "day-of-month"
     * @const
     */
    "day-of-month": "day-of-month",
    /**
     * value: "last-day-of-month"
     * @const
     */
    "last-day-of-month": "last-day-of-month",
    /**
     * value: "custom"
     * @const
     */
    "custom": "custom"  };

  /**
   * Allowed values for the <code>weekOfMonth</code> property.
   * @enum {String}
   * @readonly
   */
  exports.WeekOfMonthEnum = {
    /**
     * value: "first"
     * @const
     */
    "first": "first",
    /**
     * value: "second"
     * @const
     */
    "second": "second",
    /**
     * value: "third"
     * @const
     */
    "third": "third",
    /**
     * value: "fourth"
     * @const
     */
    "fourth": "fourth",
    /**
     * value: "last"
     * @const
     */
    "last": "last"  };

  /**
   * Allowed values for the <code>dayOfWeek</code> property.
   * @enum {String}
   * @readonly
   */
  exports.DayOfWeekEnum = {
    /**
     * value: "sunday"
     * @const
     */
    "sunday": "sunday",
    /**
     * value: "monday"
     * @const
     */
    "monday": "monday",
    /**
     * value: "tuesday"
     * @const
     */
    "tuesday": "tuesday",
    /**
     * value: "wednesday"
     * @const
     */
    "wednesday": "wednesday",
    /**
     * value: "thursday"
     * @const
     */
    "thursday": "thursday",
    /**
     * value: "friday"
     * @const
     */
    "friday": "friday",
    /**
     * value: "saturday"
     * @const
     */
    "saturday": "saturday"  };

  /**
   * Allowed values for the <code>months</code> property.
   * @enum {String}
   * @readonly
   */
  exports.MonthsEnum = {
    /**
     * value: "january"
     * @const
     */
    "january": "january",
    /**
     * value: "feburary"
     * @const
     */
    "feburary": "feburary",
    /**
     * value: "march"
     * @const
     */
    "march": "march",
    /**
     * value: "april"
     * @const
     */
    "april": "april",
    /**
     * value: "may"
     * @const
     */
    "may": "may",
    /**
     * value: "june"
     * @const
     */
    "june": "june",
    /**
     * value: "july"
     * @const
     */
    "july": "july",
    /**
     * value: "august"
     * @const
     */
    "august": "august",
    /**
     * value: "september"
     * @const
     */
    "september": "september",
    /**
     * value: "october"
     * @const
     */
    "october": "october",
    /**
     * value: "november"
     * @const
     */
    "november": "november",
    /**
     * value: "december"
     * @const
     */
    "december": "december"  };


  return exports;
}));



