/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.0.466
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.NoConnectorVirtualMachineSummary = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The NoConnectorVirtualMachineSummary model module.
   * @module model/NoConnectorVirtualMachineSummary
   * @version 12.0.466
   */

  /**
   * Constructs a new <code>NoConnectorVirtualMachineSummary</code>.
   * Details of an AWS virtual machine that was added to Deep Security Manager using the legacy Add Cloud Account wizard.
   * @alias module:model/NoConnectorVirtualMachineSummary
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>NoConnectorVirtualMachineSummary</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/NoConnectorVirtualMachineSummary} obj Optional instance to populate.
   * @return {module:model/NoConnectorVirtualMachineSummary} The populated <code>NoConnectorVirtualMachineSummary</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('accountID')) {
        obj['accountID'] = ApiClient.convertToType(data['accountID'], 'String');
      }
      if (data.hasOwnProperty('directoryID')) {
        obj['directoryID'] = ApiClient.convertToType(data['directoryID'], 'String');
      }
      if (data.hasOwnProperty('userName')) {
        obj['userName'] = ApiClient.convertToType(data['userName'], 'String');
      }
      if (data.hasOwnProperty('instanceID')) {
        obj['instanceID'] = ApiClient.convertToType(data['instanceID'], 'String');
      }
      if (data.hasOwnProperty('region')) {
        obj['region'] = ApiClient.convertToType(data['region'], 'String');
      }
    }
    return obj;
  }

  /**
   * Agent-reported account ID. Searchable as String.
   * @member {String} accountID
   */
  exports.prototype['accountID'] = undefined;
  /**
   * Agent-reported directory ID. Searchable as String.
   * @member {String} directoryID
   */
  exports.prototype['directoryID'] = undefined;
  /**
   * Agent-reported user ID. Searchable as String.
   * @member {String} userName
   */
  exports.prototype['userName'] = undefined;
  /**
   * Agent-reported instance ID. Searchable as String.
   * @member {String} instanceID
   */
  exports.prototype['instanceID'] = undefined;
  /**
   * Agent-reported region. Searchable as String.
   * @member {String} region
   */
  exports.prototype['region'] = undefined;



  return exports;
}));



