/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.0.466
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.Schedule = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Schedule model module.
   * @module model/Schedule
   * @version 12.0.466
   */

  /**
   * Constructs a new <code>Schedule</code>.
   * Schedules are reusable timetables that you can assign to rules, agent upgrades, and more.
   * @alias module:model/Schedule
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>Schedule</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Schedule} obj Optional instance to populate.
   * @return {module:model/Schedule} The populated <code>Schedule</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('hoursOfWeek')) {
        obj['hoursOfWeek'] = ApiClient.convertToType(data['hoursOfWeek'], ['Boolean']);
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Display name of the Schedule. Searchable as String.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Description of the Schedule. Searchable as String.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * An array of 168 boolean values representing each hour in the week starting Sunday at 0:00. A value of 'true' marks the given hour as 'on'.
   * @member {Array.<Boolean>} hoursOfWeek
   */
  exports.prototype['hoursOfWeek'] = undefined;
  /**
   * ID of the Schedule. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;



  return exports;
}));



