/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.0.466
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/DailyScheduleParameters', 'model/HourlyScheduleParameters', 'model/MonthlyScheduleParameters', 'model/OnceOnlyScheduleParameters', 'model/WeeklyScheduleParameters'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./DailyScheduleParameters'), require('./HourlyScheduleParameters'), require('./MonthlyScheduleParameters'), require('./OnceOnlyScheduleParameters'), require('./WeeklyScheduleParameters'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ScheduleDetails = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.DailyScheduleParameters, root.Deepsecurity.HourlyScheduleParameters, root.Deepsecurity.MonthlyScheduleParameters, root.Deepsecurity.OnceOnlyScheduleParameters, root.Deepsecurity.WeeklyScheduleParameters);
  }
}(this, function(ApiClient, DailyScheduleParameters, HourlyScheduleParameters, MonthlyScheduleParameters, OnceOnlyScheduleParameters, WeeklyScheduleParameters) {
  'use strict';




  /**
   * The ScheduleDetails model module.
   * @module model/ScheduleDetails
   * @version 12.0.466
   */

  /**
   * Constructs a new <code>ScheduleDetails</code>.
   * Controls when a scheduled task runs.
   * @alias module:model/ScheduleDetails
   * @class
   */
  var exports = function() {
    var _this = this;









  };

  /**
   * Constructs a <code>ScheduleDetails</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ScheduleDetails} obj Optional instance to populate.
   * @return {module:model/ScheduleDetails} The populated <code>ScheduleDetails</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('timeZone')) {
        obj['timeZone'] = ApiClient.convertToType(data['timeZone'], 'String');
      }
      if (data.hasOwnProperty('recurrenceType')) {
        obj['recurrenceType'] = ApiClient.convertToType(data['recurrenceType'], 'String');
      }
      if (data.hasOwnProperty('recurrenceCount')) {
        obj['recurrenceCount'] = ApiClient.convertToType(data['recurrenceCount'], 'Number');
      }
      if (data.hasOwnProperty('hourlyScheduleParameters')) {
        obj['hourlyScheduleParameters'] = HourlyScheduleParameters.constructFromObject(data['hourlyScheduleParameters']);
      }
      if (data.hasOwnProperty('dailyScheduleParameters')) {
        obj['dailyScheduleParameters'] = DailyScheduleParameters.constructFromObject(data['dailyScheduleParameters']);
      }
      if (data.hasOwnProperty('weeklyScheduleParameters')) {
        obj['weeklyScheduleParameters'] = WeeklyScheduleParameters.constructFromObject(data['weeklyScheduleParameters']);
      }
      if (data.hasOwnProperty('monthlyScheduleParameters')) {
        obj['monthlyScheduleParameters'] = MonthlyScheduleParameters.constructFromObject(data['monthlyScheduleParameters']);
      }
      if (data.hasOwnProperty('onceOnlyScheduleParameters')) {
        obj['onceOnlyScheduleParameters'] = OnceOnlyScheduleParameters.constructFromObject(data['onceOnlyScheduleParameters']);
      }
    }
    return obj;
  }

  /**
   * The timezone used to interpret the scheduled task schedule.
   * @member {String} timeZone
   */
  exports.prototype['timeZone'] = undefined;
  /**
   * Recurrence type.
   * @member {module:model/ScheduleDetails.RecurrenceTypeEnum} recurrenceType
   */
  exports.prototype['recurrenceType'] = undefined;
  /**
   * Number of times the task should execute.
   * @member {Number} recurrenceCount
   */
  exports.prototype['recurrenceCount'] = undefined;
  /**
   * Details for an hourly schedule.
   * @member {module:model/HourlyScheduleParameters} hourlyScheduleParameters
   */
  exports.prototype['hourlyScheduleParameters'] = undefined;
  /**
   * Details for a daily schedule.
   * @member {module:model/DailyScheduleParameters} dailyScheduleParameters
   */
  exports.prototype['dailyScheduleParameters'] = undefined;
  /**
   * Details for a weekly schedule.
   * @member {module:model/WeeklyScheduleParameters} weeklyScheduleParameters
   */
  exports.prototype['weeklyScheduleParameters'] = undefined;
  /**
   * Details for a monthly schedule.
   * @member {module:model/MonthlyScheduleParameters} monthlyScheduleParameters
   */
  exports.prototype['monthlyScheduleParameters'] = undefined;
  /**
   * Details for a once only schedule.
   * @member {module:model/OnceOnlyScheduleParameters} onceOnlyScheduleParameters
   */
  exports.prototype['onceOnlyScheduleParameters'] = undefined;


  /**
   * Allowed values for the <code>recurrenceType</code> property.
   * @enum {String}
   * @readonly
   */
  exports.RecurrenceTypeEnum = {
    /**
     * value: "none"
     * @const
     */
    "none": "none",
    /**
     * value: "hourly"
     * @const
     */
    "hourly": "hourly",
    /**
     * value: "daily"
     * @const
     */
    "daily": "daily",
    /**
     * value: "weekly"
     * @const
     */
    "weekly": "weekly",
    /**
     * value: "monthly"
     * @const
     */
    "monthly": "monthly"  };


  return exports;
}));



