/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.0.466
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.SynchronizeVCenterTaskParameters = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The SynchronizeVCenterTaskParameters model module.
   * @module model/SynchronizeVCenterTaskParameters
   * @version 12.0.466
   */

  /**
   * Constructs a new <code>SynchronizeVCenterTaskParameters</code>.
   * Controls the behavior of a scheduled task of type synchronize-vcenter.
   * @alias module:model/SynchronizeVCenterTaskParameters
   * @class
   */
  var exports = function() {
    var _this = this;


  };

  /**
   * Constructs a <code>SynchronizeVCenterTaskParameters</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SynchronizeVCenterTaskParameters} obj Optional instance to populate.
   * @return {module:model/SynchronizeVCenterTaskParameters} The populated <code>SynchronizeVCenterTaskParameters</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('computerGroupID')) {
        obj['computerGroupID'] = ApiClient.convertToType(data['computerGroupID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Identifies the top-level computer group for the vCenter.
   * @member {Number} computerGroupID
   */
  exports.prototype['computerGroupID'] = undefined;



  return exports;
}));



