/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.0.466
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/SettingValue'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./SettingValue'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.SystemSettings = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.SettingValue);
  }
}(this, function(ApiClient, SettingValue) {
  'use strict';




  /**
   * The SystemSettings model module.
   * @module model/SystemSettings
   * @version 12.0.466
   */

  /**
   * Constructs a new <code>SystemSettings</code>.
   * @alias module:model/SystemSettings
   * @class
   */
  var exports = function() {
    var _this = this;




































































































































































































  };

  /**
   * Constructs a <code>SystemSettings</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SystemSettings} obj Optional instance to populate.
   * @return {module:model/SystemSettings} The populated <code>SystemSettings</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('platformSettingSamlIdentityProviderCertificateExpiryWarningDays')) {
        obj['platformSettingSamlIdentityProviderCertificateExpiryWarningDays'] = SettingValue.constructFromObject(data['platformSettingSamlIdentityProviderCertificateExpiryWarningDays']);
      }
      if (data.hasOwnProperty('platformSettingUpdateAgentSecurityOnMissingDeepSecurityManagerEnabled')) {
        obj['platformSettingUpdateAgentSecurityOnMissingDeepSecurityManagerEnabled'] = SettingValue.constructFromObject(data['platformSettingUpdateAgentSecurityOnMissingDeepSecurityManagerEnabled']);
      }
      if (data.hasOwnProperty('platformSettingDdanManualSourceServerUrl')) {
        obj['platformSettingDdanManualSourceServerUrl'] = SettingValue.constructFromObject(data['platformSettingDdanManualSourceServerUrl']);
      }
      if (data.hasOwnProperty('platformSettingLoadBalancerManagerPort')) {
        obj['platformSettingLoadBalancerManagerPort'] = SettingValue.constructFromObject(data['platformSettingLoadBalancerManagerPort']);
      }
      if (data.hasOwnProperty('platformSettingSmartProtectionFeedbackThreatDetectionsThreshold')) {
        obj['platformSettingSmartProtectionFeedbackThreatDetectionsThreshold'] = SettingValue.constructFromObject(data['platformSettingSmartProtectionFeedbackThreatDetectionsThreshold']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantRunPortScanEnabled')) {
        obj['platformSettingPrimaryTenantAllowTenantRunPortScanEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantRunPortScanEnabled']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingEventRankSeverityFilterMedium')) {
        obj['intrusionPreventionSettingEventRankSeverityFilterMedium'] = SettingValue.constructFromObject(data['intrusionPreventionSettingEventRankSeverityFilterMedium']);
      }
      if (data.hasOwnProperty('firewallSettingIntranetConnectivityTestExpectedContentRegex')) {
        obj['firewallSettingIntranetConnectivityTestExpectedContentRegex'] = SettingValue.constructFromObject(data['firewallSettingIntranetConnectivityTestExpectedContentRegex']);
      }
      if (data.hasOwnProperty('platformSettingEventForwardingSnsEnabled')) {
        obj['platformSettingEventForwardingSnsEnabled'] = SettingValue.constructFromObject(data['platformSettingEventForwardingSnsEnabled']);
      }
      if (data.hasOwnProperty('platformSettingTenantAutoRevokeImpersonationByPrimaryTenantTimeout')) {
        obj['platformSettingTenantAutoRevokeImpersonationByPrimaryTenantTimeout'] = SettingValue.constructFromObject(data['platformSettingTenantAutoRevokeImpersonationByPrimaryTenantTimeout']);
      }
      if (data.hasOwnProperty('webReputationSettingEventRankRiskBlockedByAdministratorRank')) {
        obj['webReputationSettingEventRankRiskBlockedByAdministratorRank'] = SettingValue.constructFromObject(data['webReputationSettingEventRankRiskBlockedByAdministratorRank']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantLockAndHideTenantStorageTabEnabled')) {
        obj['platformSettingPrimaryTenantLockAndHideTenantStorageTabEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantLockAndHideTenantStorageTabEnabled']);
      }
      if (data.hasOwnProperty('antiMalwareSettingEventEmailRecipients')) {
        obj['antiMalwareSettingEventEmailRecipients'] = SettingValue.constructFromObject(data['antiMalwareSettingEventEmailRecipients']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantUseDefaultRelayGroupEnabled')) {
        obj['platformSettingPrimaryTenantAllowTenantUseDefaultRelayGroupEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantUseDefaultRelayGroupEnabled']);
      }
      if (data.hasOwnProperty('platformSettingHttpStrictTransportEnabled')) {
        obj['platformSettingHttpStrictTransportEnabled'] = SettingValue.constructFromObject(data['platformSettingHttpStrictTransportEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingIntranetConnectivityTestUrl')) {
        obj['firewallSettingIntranetConnectivityTestUrl'] = SettingValue.constructFromObject(data['firewallSettingIntranetConnectivityTestUrl']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantConfigureSnsEnabled')) {
        obj['platformSettingPrimaryTenantAllowTenantConfigureSnsEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantConfigureSnsEnabled']);
      }
      if (data.hasOwnProperty('platformSettingTenantUseDefaultRelayGroupFromPrimaryTenantEnabled')) {
        obj['platformSettingTenantUseDefaultRelayGroupFromPrimaryTenantEnabled'] = SettingValue.constructFromObject(data['platformSettingTenantUseDefaultRelayGroupFromPrimaryTenantEnabled']);
      }
      if (data.hasOwnProperty('platformSettingExportedDiagnosticPackageLocale')) {
        obj['platformSettingExportedDiagnosticPackageLocale'] = SettingValue.constructFromObject(data['platformSettingExportedDiagnosticPackageLocale']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingEventRankSeverityFilterCritical')) {
        obj['intrusionPreventionSettingEventRankSeverityFilterCritical'] = SettingValue.constructFromObject(data['intrusionPreventionSettingEventRankSeverityFilterCritical']);
      }
      if (data.hasOwnProperty('platformSettingUpdateImportedSoftwareAutoDownloadEnabled')) {
        obj['platformSettingUpdateImportedSoftwareAutoDownloadEnabled'] = SettingValue.constructFromObject(data['platformSettingUpdateImportedSoftwareAutoDownloadEnabled']);
      }
      if (data.hasOwnProperty('platformSettingDemoModeEnabled')) {
        obj['platformSettingDemoModeEnabled'] = SettingValue.constructFromObject(data['platformSettingDemoModeEnabled']);
      }
      if (data.hasOwnProperty('platformSettingUserEnforceTermsAndConditionsMessage')) {
        obj['platformSettingUserEnforceTermsAndConditionsMessage'] = SettingValue.constructFromObject(data['platformSettingUserEnforceTermsAndConditionsMessage']);
      }
      if (data.hasOwnProperty('platformSettingManagedDetectResponseCompanyGuid')) {
        obj['platformSettingManagedDetectResponseCompanyGuid'] = SettingValue.constructFromObject(data['platformSettingManagedDetectResponseCompanyGuid']);
      }
      if (data.hasOwnProperty('platformSettingAlertDefaultEmailAddress')) {
        obj['platformSettingAlertDefaultEmailAddress'] = SettingValue.constructFromObject(data['platformSettingAlertDefaultEmailAddress']);
      }
      if (data.hasOwnProperty('platformSettingAgentInitiatedActivationReactivateClonedEnabled')) {
        obj['platformSettingAgentInitiatedActivationReactivateClonedEnabled'] = SettingValue.constructFromObject(data['platformSettingAgentInitiatedActivationReactivateClonedEnabled']);
      }
      if (data.hasOwnProperty('platformSettingManagedDetectResponseServerUrl')) {
        obj['platformSettingManagedDetectResponseServerUrl'] = SettingValue.constructFromObject(data['platformSettingManagedDetectResponseServerUrl']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantShareManagedDetectResponsesEnabled')) {
        obj['platformSettingPrimaryTenantShareManagedDetectResponsesEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantShareManagedDetectResponsesEnabled']);
      }
      if (data.hasOwnProperty('platformSettingSamlServiceProviderCertificate')) {
        obj['platformSettingSamlServiceProviderCertificate'] = SettingValue.constructFromObject(data['platformSettingSamlServiceProviderCertificate']);
      }
      if (data.hasOwnProperty('platformSettingSyslogConfigId')) {
        obj['platformSettingSyslogConfigId'] = SettingValue.constructFromObject(data['platformSettingSyslogConfigId']);
      }
      if (data.hasOwnProperty('platformSettingSmtpStartTlsEnabled')) {
        obj['platformSettingSmtpStartTlsEnabled'] = SettingValue.constructFromObject(data['platformSettingSmtpStartTlsEnabled']);
      }
      if (data.hasOwnProperty('platformSettingUserPasswordRequireLettersAndNumbersEnabled')) {
        obj['platformSettingUserPasswordRequireLettersAndNumbersEnabled'] = SettingValue.constructFromObject(data['platformSettingUserPasswordRequireLettersAndNumbersEnabled']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantSynchronizeLdapDirectoriesEnabled')) {
        obj['platformSettingPrimaryTenantAllowTenantSynchronizeLdapDirectoriesEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantSynchronizeLdapDirectoriesEnabled']);
      }
      if (data.hasOwnProperty('platformSettingLoadBalancerRelayPort')) {
        obj['platformSettingLoadBalancerRelayPort'] = SettingValue.constructFromObject(data['platformSettingLoadBalancerRelayPort']);
      }
      if (data.hasOwnProperty('platformSettingManagedDetectResponseEnabled')) {
        obj['platformSettingManagedDetectResponseEnabled'] = SettingValue.constructFromObject(data['platformSettingManagedDetectResponseEnabled']);
      }
      if (data.hasOwnProperty('platformSettingUpdateRulesPolicyAutoApplyEnabled')) {
        obj['platformSettingUpdateRulesPolicyAutoApplyEnabled'] = SettingValue.constructFromObject(data['platformSettingUpdateRulesPolicyAutoApplyEnabled']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantConfigureForgotPasswordEnabled')) {
        obj['platformSettingPrimaryTenantAllowTenantConfigureForgotPasswordEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantConfigureForgotPasswordEnabled']);
      }
      if (data.hasOwnProperty('platformSettingUserPasswordRequireNotSameAsUsernameEnabled')) {
        obj['platformSettingUserPasswordRequireNotSameAsUsernameEnabled'] = SettingValue.constructFromObject(data['platformSettingUserPasswordRequireNotSameAsUsernameEnabled']);
      }
      if (data.hasOwnProperty('logInspectionSettingEventRankSeverityMedium')) {
        obj['logInspectionSettingEventRankSeverityMedium'] = SettingValue.constructFromObject(data['logInspectionSettingEventRankSeverityMedium']);
      }
      if (data.hasOwnProperty('antiMalwareSettingRetainEventDuration')) {
        obj['antiMalwareSettingRetainEventDuration'] = SettingValue.constructFromObject(data['antiMalwareSettingRetainEventDuration']);
      }
      if (data.hasOwnProperty('platformSettingUpdateAgentSecurityContactPrimarySourceOnMissingRelayEnabled')) {
        obj['platformSettingUpdateAgentSecurityContactPrimarySourceOnMissingRelayEnabled'] = SettingValue.constructFromObject(data['platformSettingUpdateAgentSecurityContactPrimarySourceOnMissingRelayEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEventRankSeverityLogOnly')) {
        obj['firewallSettingEventRankSeverityLogOnly'] = SettingValue.constructFromObject(data['firewallSettingEventRankSeverityLogOnly']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantLockAndHideTenantDataPrivacyOptionEnabled')) {
        obj['platformSettingPrimaryTenantLockAndHideTenantDataPrivacyOptionEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantLockAndHideTenantDataPrivacyOptionEnabled']);
      }
      if (data.hasOwnProperty('applicationControlSettingRetainEventDuration')) {
        obj['applicationControlSettingRetainEventDuration'] = SettingValue.constructFromObject(data['applicationControlSettingRetainEventDuration']);
      }
      if (data.hasOwnProperty('platformSettingApiSoapWebServiceEnabled')) {
        obj['platformSettingApiSoapWebServiceEnabled'] = SettingValue.constructFromObject(data['platformSettingApiSoapWebServiceEnabled']);
      }
      if (data.hasOwnProperty('platformSettingSamlServiceProviderPrivateKey')) {
        obj['platformSettingSamlServiceProviderPrivateKey'] = SettingValue.constructFromObject(data['platformSettingSamlServiceProviderPrivateKey']);
      }
      if (data.hasOwnProperty('platformSettingSystemEventForwardingSnmpPort')) {
        obj['platformSettingSystemEventForwardingSnmpPort'] = SettingValue.constructFromObject(data['platformSettingSystemEventForwardingSnmpPort']);
      }
      if (data.hasOwnProperty('firewallSettingEventRankSeverityDeny')) {
        obj['firewallSettingEventRankSeverityDeny'] = SettingValue.constructFromObject(data['firewallSettingEventRankSeverityDeny']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingEventRankSeverityFilterLow')) {
        obj['intrusionPreventionSettingEventRankSeverityFilterLow'] = SettingValue.constructFromObject(data['intrusionPreventionSettingEventRankSeverityFilterLow']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantControlImpersonationEnabled')) {
        obj['platformSettingPrimaryTenantAllowTenantControlImpersonationEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantControlImpersonationEnabled']);
      }
      if (data.hasOwnProperty('platformSettingRecommendationCpuUsageLevel')) {
        obj['platformSettingRecommendationCpuUsageLevel'] = SettingValue.constructFromObject(data['platformSettingRecommendationCpuUsageLevel']);
      }
      if (data.hasOwnProperty('platformSettingManagedDetectResponseServiceToken')) {
        obj['platformSettingManagedDetectResponseServiceToken'] = SettingValue.constructFromObject(data['platformSettingManagedDetectResponseServiceToken']);
      }
      if (data.hasOwnProperty('platformSettingLoadBalancerHeartbeatAddress')) {
        obj['platformSettingLoadBalancerHeartbeatAddress'] = SettingValue.constructFromObject(data['platformSettingLoadBalancerHeartbeatAddress']);
      }
      if (data.hasOwnProperty('platformSettingContentSecurityPolicyReportOnlyEnabled')) {
        obj['platformSettingContentSecurityPolicyReportOnlyEnabled'] = SettingValue.constructFromObject(data['platformSettingContentSecurityPolicyReportOnlyEnabled']);
      }
      if (data.hasOwnProperty('logInspectionSettingRetainEventDuration')) {
        obj['logInspectionSettingRetainEventDuration'] = SettingValue.constructFromObject(data['logInspectionSettingRetainEventDuration']);
      }
      if (data.hasOwnProperty('platformSettingTenantAutoRevokeImpersonationByPrimaryTenantEnabled')) {
        obj['platformSettingTenantAutoRevokeImpersonationByPrimaryTenantEnabled'] = SettingValue.constructFromObject(data['platformSettingTenantAutoRevokeImpersonationByPrimaryTenantEnabled']);
      }
      if (data.hasOwnProperty('antiMalwareSettingEventEmailBodyTemplate')) {
        obj['antiMalwareSettingEventEmailBodyTemplate'] = SettingValue.constructFromObject(data['antiMalwareSettingEventEmailBodyTemplate']);
      }
      if (data.hasOwnProperty('platformSettingRetainSecurityUpdatesMax')) {
        obj['platformSettingRetainSecurityUpdatesMax'] = SettingValue.constructFromObject(data['platformSettingRetainSecurityUpdatesMax']);
      }
      if (data.hasOwnProperty('platformSettingConnectedThreatDefenseControlManagerSourceOption')) {
        obj['platformSettingConnectedThreatDefenseControlManagerSourceOption'] = SettingValue.constructFromObject(data['platformSettingConnectedThreatDefenseControlManagerSourceOption']);
      }
      if (data.hasOwnProperty('antiMalwareSettingEventEmailEnabled')) {
        obj['antiMalwareSettingEventEmailEnabled'] = SettingValue.constructFromObject(data['antiMalwareSettingEventEmailEnabled']);
      }
      if (data.hasOwnProperty('platformSettingUpdateAgentSoftwareUseDownloadCenterOnMissingDeepSecurityManagerEnabled')) {
        obj['platformSettingUpdateAgentSoftwareUseDownloadCenterOnMissingDeepSecurityManagerEnabled'] = SettingValue.constructFromObject(data['platformSettingUpdateAgentSoftwareUseDownloadCenterOnMissingDeepSecurityManagerEnabled']);
      }
      if (data.hasOwnProperty('platformSettingRecommendationOngoingScansEnabled')) {
        obj['platformSettingRecommendationOngoingScansEnabled'] = SettingValue.constructFromObject(data['platformSettingRecommendationOngoingScansEnabled']);
      }
      if (data.hasOwnProperty('platformSettingAgentInitiatedActivationToken')) {
        obj['platformSettingAgentInitiatedActivationToken'] = SettingValue.constructFromObject(data['platformSettingAgentInitiatedActivationToken']);
      }
      if (data.hasOwnProperty('platformSettingUserPasswordLengthMin')) {
        obj['platformSettingUserPasswordLengthMin'] = SettingValue.constructFromObject(data['platformSettingUserPasswordLengthMin']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantDatabaseState')) {
        obj['platformSettingPrimaryTenantAllowTenantDatabaseState'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantDatabaseState']);
      }
      if (data.hasOwnProperty('platformSettingAwsManagerIdentityUseInstanceRoleEnabled')) {
        obj['platformSettingAwsManagerIdentityUseInstanceRoleEnabled'] = SettingValue.constructFromObject(data['platformSettingAwsManagerIdentityUseInstanceRoleEnabled']);
      }
      if (data.hasOwnProperty('platformSettingContentSecurityPolicy')) {
        obj['platformSettingContentSecurityPolicy'] = SettingValue.constructFromObject(data['platformSettingContentSecurityPolicy']);
      }
      if (data.hasOwnProperty('platformSettingProductUsageDataCollectionEnabled')) {
        obj['platformSettingProductUsageDataCollectionEnabled'] = SettingValue.constructFromObject(data['platformSettingProductUsageDataCollectionEnabled']);
      }
      if (data.hasOwnProperty('platformSettingAlertAgentUpdatePendingThreshold')) {
        obj['platformSettingAlertAgentUpdatePendingThreshold'] = SettingValue.constructFromObject(data['platformSettingAlertAgentUpdatePendingThreshold']);
      }
      if (data.hasOwnProperty('platformSettingUserPasswordRequireSpecialCharactersEnabled')) {
        obj['platformSettingUserPasswordRequireSpecialCharactersEnabled'] = SettingValue.constructFromObject(data['platformSettingUserPasswordRequireSpecialCharactersEnabled']);
      }
      if (data.hasOwnProperty('platformSettingUpdateApplianceDefaultAgentVersion')) {
        obj['platformSettingUpdateApplianceDefaultAgentVersion'] = SettingValue.constructFromObject(data['platformSettingUpdateApplianceDefaultAgentVersion']);
      }
      if (data.hasOwnProperty('platformSettingSystemEventForwardingSnmpEnabled')) {
        obj['platformSettingSystemEventForwardingSnmpEnabled'] = SettingValue.constructFromObject(data['platformSettingSystemEventForwardingSnmpEnabled']);
      }
      if (data.hasOwnProperty('platformSettingSmtpBounceEmailAddress')) {
        obj['platformSettingSmtpBounceEmailAddress'] = SettingValue.constructFromObject(data['platformSettingSmtpBounceEmailAddress']);
      }
      if (data.hasOwnProperty('platformSettingUpdateRelaySecuritySupportAgent9AndEarlierEnabled')) {
        obj['platformSettingUpdateRelaySecuritySupportAgent9AndEarlierEnabled'] = SettingValue.constructFromObject(data['platformSettingUpdateRelaySecuritySupportAgent9AndEarlierEnabled']);
      }
      if (data.hasOwnProperty('platformSettingManagedDetectResponseProxyId')) {
        obj['platformSettingManagedDetectResponseProxyId'] = SettingValue.constructFromObject(data['platformSettingManagedDetectResponseProxyId']);
      }
      if (data.hasOwnProperty('platformSettingInactiveAgentCleanupEnabled')) {
        obj['platformSettingInactiveAgentCleanupEnabled'] = SettingValue.constructFromObject(data['platformSettingInactiveAgentCleanupEnabled']);
      }
      if (data.hasOwnProperty('platformSettingLoadBalancerRelayAddress')) {
        obj['platformSettingLoadBalancerRelayAddress'] = SettingValue.constructFromObject(data['platformSettingLoadBalancerRelayAddress']);
      }
      if (data.hasOwnProperty('platformSettingHttpPublicKeyPinPolicy')) {
        obj['platformSettingHttpPublicKeyPinPolicy'] = SettingValue.constructFromObject(data['platformSettingHttpPublicKeyPinPolicy']);
      }
      if (data.hasOwnProperty('platformSettingUserSessionIdleTimeout')) {
        obj['platformSettingUserSessionIdleTimeout'] = SettingValue.constructFromObject(data['platformSettingUserSessionIdleTimeout']);
      }
      if (data.hasOwnProperty('antiMalwareSettingEventEmailSubject')) {
        obj['antiMalwareSettingEventEmailSubject'] = SettingValue.constructFromObject(data['antiMalwareSettingEventEmailSubject']);
      }
      if (data.hasOwnProperty('platformSettingConnectedThreatDefenseControlManagerUseProxyEnabled')) {
        obj['platformSettingConnectedThreatDefenseControlManagerUseProxyEnabled'] = SettingValue.constructFromObject(data['platformSettingConnectedThreatDefenseControlManagerUseProxyEnabled']);
      }
      if (data.hasOwnProperty('platformSettingUserEnforceTermsAndConditionsEnabled')) {
        obj['platformSettingUserEnforceTermsAndConditionsEnabled'] = SettingValue.constructFromObject(data['platformSettingUserEnforceTermsAndConditionsEnabled']);
      }
      if (data.hasOwnProperty('platformSettingAwsManagerIdentityAccessKey')) {
        obj['platformSettingAwsManagerIdentityAccessKey'] = SettingValue.constructFromObject(data['platformSettingAwsManagerIdentityAccessKey']);
      }
      if (data.hasOwnProperty('platformSettingConnectedThreatDefenseControlManagerProxyId')) {
        obj['platformSettingConnectedThreatDefenseControlManagerProxyId'] = SettingValue.constructFromObject(data['platformSettingConnectedThreatDefenseControlManagerProxyId']);
      }
      if (data.hasOwnProperty('platformSettingTenantAllowImpersonationByPrimaryTenantEnabled')) {
        obj['platformSettingTenantAllowImpersonationByPrimaryTenantEnabled'] = SettingValue.constructFromObject(data['platformSettingTenantAllowImpersonationByPrimaryTenantEnabled']);
      }
      if (data.hasOwnProperty('platformSettingConnectedThreatDefenseControlManagerManualSourceServerUrl')) {
        obj['platformSettingConnectedThreatDefenseControlManagerManualSourceServerUrl'] = SettingValue.constructFromObject(data['platformSettingConnectedThreatDefenseControlManagerManualSourceServerUrl']);
      }
      if (data.hasOwnProperty('platformSettingUserPasswordRequireMixedCaseEnabled')) {
        obj['platformSettingUserPasswordRequireMixedCaseEnabled'] = SettingValue.constructFromObject(data['platformSettingUserPasswordRequireMixedCaseEnabled']);
      }
      if (data.hasOwnProperty('platformSettingSmartProtectionFeedbackForSuspiciousFileEnabled')) {
        obj['platformSettingSmartProtectionFeedbackForSuspiciousFileEnabled'] = SettingValue.constructFromObject(data['platformSettingSmartProtectionFeedbackForSuspiciousFileEnabled']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantConfigureSnmpEnabled')) {
        obj['platformSettingPrimaryTenantAllowTenantConfigureSnmpEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantConfigureSnmpEnabled']);
      }
      if (data.hasOwnProperty('platformSettingSmartProtectionFeedbackIndustryType')) {
        obj['platformSettingSmartProtectionFeedbackIndustryType'] = SettingValue.constructFromObject(data['platformSettingSmartProtectionFeedbackIndustryType']);
      }
      if (data.hasOwnProperty('webReputationSettingRetainEventDuration')) {
        obj['webReputationSettingRetainEventDuration'] = SettingValue.constructFromObject(data['webReputationSettingRetainEventDuration']);
      }
      if (data.hasOwnProperty('platformSettingRetainServerLogDuration')) {
        obj['platformSettingRetainServerLogDuration'] = SettingValue.constructFromObject(data['platformSettingRetainServerLogDuration']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingEventRankSeverityMedium')) {
        obj['integrityMonitoringSettingEventRankSeverityMedium'] = SettingValue.constructFromObject(data['integrityMonitoringSettingEventRankSeverityMedium']);
      }
      if (data.hasOwnProperty('platformSettingProxyManagerCloudProxyId')) {
        obj['platformSettingProxyManagerCloudProxyId'] = SettingValue.constructFromObject(data['platformSettingProxyManagerCloudProxyId']);
      }
      if (data.hasOwnProperty('platformSettingUpdateRelaySecurityAllRegionsPatternsDownloadEnabled')) {
        obj['platformSettingUpdateRelaySecurityAllRegionsPatternsDownloadEnabled'] = SettingValue.constructFromObject(data['platformSettingUpdateRelaySecurityAllRegionsPatternsDownloadEnabled']);
      }
      if (data.hasOwnProperty('platformSettingDdanSubmissionEnabled')) {
        obj['platformSettingDdanSubmissionEnabled'] = SettingValue.constructFromObject(data['platformSettingDdanSubmissionEnabled']);
      }
      if (data.hasOwnProperty('webReputationSettingEventRankRiskSuspicious')) {
        obj['webReputationSettingEventRankRiskSuspicious'] = SettingValue.constructFromObject(data['webReputationSettingEventRankRiskSuspicious']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingEventRankSeverityCritical')) {
        obj['integrityMonitoringSettingEventRankSeverityCritical'] = SettingValue.constructFromObject(data['integrityMonitoringSettingEventRankSeverityCritical']);
      }
      if (data.hasOwnProperty('platformSettingSmtpFromEmailAddress')) {
        obj['platformSettingSmtpFromEmailAddress'] = SettingValue.constructFromObject(data['platformSettingSmtpFromEmailAddress']);
      }
      if (data.hasOwnProperty('firewallSettingGlobalStatefulConfigId')) {
        obj['firewallSettingGlobalStatefulConfigId'] = SettingValue.constructFromObject(data['firewallSettingGlobalStatefulConfigId']);
      }
      if (data.hasOwnProperty('platformSettingEventForwardingSnsTopicArn')) {
        obj['platformSettingEventForwardingSnsTopicArn'] = SettingValue.constructFromObject(data['platformSettingEventForwardingSnsTopicArn']);
      }
      if (data.hasOwnProperty('firewallSettingInternetConnectivityTestExpectedContentRegex')) {
        obj['firewallSettingInternetConnectivityTestExpectedContentRegex'] = SettingValue.constructFromObject(data['firewallSettingInternetConnectivityTestExpectedContentRegex']);
      }
      if (data.hasOwnProperty('platformSettingConnectedThreatDefenseControlManagerManualSourceApiKey')) {
        obj['platformSettingConnectedThreatDefenseControlManagerManualSourceApiKey'] = SettingValue.constructFromObject(data['platformSettingConnectedThreatDefenseControlManagerManualSourceApiKey']);
      }
      if (data.hasOwnProperty('platformSettingLoadBalancerManagerAddress')) {
        obj['platformSettingLoadBalancerManagerAddress'] = SettingValue.constructFromObject(data['platformSettingLoadBalancerManagerAddress']);
      }
      if (data.hasOwnProperty('platformSettingUpdateSecurityPrimarySourceMode')) {
        obj['platformSettingUpdateSecurityPrimarySourceMode'] = SettingValue.constructFromObject(data['platformSettingUpdateSecurityPrimarySourceMode']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantShareConnectedThreatDefensesEnabled')) {
        obj['platformSettingPrimaryTenantShareConnectedThreatDefensesEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantShareConnectedThreatDefensesEnabled']);
      }
      if (data.hasOwnProperty('webReputationSettingEventRankRiskDangerous')) {
        obj['webReputationSettingEventRankRiskDangerous'] = SettingValue.constructFromObject(data['webReputationSettingEventRankRiskDangerous']);
      }
      if (data.hasOwnProperty('platformSettingLoadBalancerHeartbeatPort')) {
        obj['platformSettingLoadBalancerHeartbeatPort'] = SettingValue.constructFromObject(data['platformSettingLoadBalancerHeartbeatPort']);
      }
      if (data.hasOwnProperty('platformSettingUserHideUnlicensedModulesEnabled')) {
        obj['platformSettingUserHideUnlicensedModulesEnabled'] = SettingValue.constructFromObject(data['platformSettingUserHideUnlicensedModulesEnabled']);
      }
      if (data.hasOwnProperty('platformSettingCaptureEncryptedTrafficEnabled')) {
        obj['platformSettingCaptureEncryptedTrafficEnabled'] = SettingValue.constructFromObject(data['platformSettingCaptureEncryptedTrafficEnabled']);
      }
      if (data.hasOwnProperty('platformSettingRetainSystemEventDuration')) {
        obj['platformSettingRetainSystemEventDuration'] = SettingValue.constructFromObject(data['platformSettingRetainSystemEventDuration']);
      }
      if (data.hasOwnProperty('platformSettingUserPasswordExpiry')) {
        obj['platformSettingUserPasswordExpiry'] = SettingValue.constructFromObject(data['platformSettingUserPasswordExpiry']);
      }
      if (data.hasOwnProperty('platformSettingSmartProtectionFeedbackEnabled')) {
        obj['platformSettingSmartProtectionFeedbackEnabled'] = SettingValue.constructFromObject(data['platformSettingSmartProtectionFeedbackEnabled']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingRetainEventDuration')) {
        obj['integrityMonitoringSettingRetainEventDuration'] = SettingValue.constructFromObject(data['integrityMonitoringSettingRetainEventDuration']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantUseScheduledRunScriptTaskEnabled')) {
        obj['platformSettingPrimaryTenantAllowTenantUseScheduledRunScriptTaskEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantUseScheduledRunScriptTaskEnabled']);
      }
      if (data.hasOwnProperty('logInspectionSettingEventRankSeverityCritical')) {
        obj['logInspectionSettingEventRankSeverityCritical'] = SettingValue.constructFromObject(data['logInspectionSettingEventRankSeverityCritical']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantLockAndHideTenantSmtpTabEnabled')) {
        obj['platformSettingPrimaryTenantLockAndHideTenantSmtpTabEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantLockAndHideTenantSmtpTabEnabled']);
      }
      if (data.hasOwnProperty('platformSettingDdanProxyId')) {
        obj['platformSettingDdanProxyId'] = SettingValue.constructFromObject(data['platformSettingDdanProxyId']);
      }
      if (data.hasOwnProperty('platformSettingAgentInitiatedActivationWithinIpListId')) {
        obj['platformSettingAgentInitiatedActivationWithinIpListId'] = SettingValue.constructFromObject(data['platformSettingAgentInitiatedActivationWithinIpListId']);
      }
      if (data.hasOwnProperty('platformSettingUpdateSecurityPrimarySourceUrl')) {
        obj['platformSettingUpdateSecurityPrimarySourceUrl'] = SettingValue.constructFromObject(data['platformSettingUpdateSecurityPrimarySourceUrl']);
      }
      if (data.hasOwnProperty('platformSettingAgentlessVcloudProtectionEnabled')) {
        obj['platformSettingAgentlessVcloudProtectionEnabled'] = SettingValue.constructFromObject(data['platformSettingAgentlessVcloudProtectionEnabled']);
      }
      if (data.hasOwnProperty('platformSettingActiveSessionsMaxExceededAction')) {
        obj['platformSettingActiveSessionsMaxExceededAction'] = SettingValue.constructFromObject(data['platformSettingActiveSessionsMaxExceededAction']);
      }
      if (data.hasOwnProperty('platformSettingUpdateHostnameOnIpChangeEnabled')) {
        obj['platformSettingUpdateHostnameOnIpChangeEnabled'] = SettingValue.constructFromObject(data['platformSettingUpdateHostnameOnIpChangeEnabled']);
      }
      if (data.hasOwnProperty('logInspectionSettingEventRankSeverityHigh')) {
        obj['logInspectionSettingEventRankSeverityHigh'] = SettingValue.constructFromObject(data['logInspectionSettingEventRankSeverityHigh']);
      }
      if (data.hasOwnProperty('platformSettingSmtpRequiresAuthenticationEnabled')) {
        obj['platformSettingSmtpRequiresAuthenticationEnabled'] = SettingValue.constructFromObject(data['platformSettingSmtpRequiresAuthenticationEnabled']);
      }
      if (data.hasOwnProperty('platformSettingActiveSessionsMax')) {
        obj['platformSettingActiveSessionsMax'] = SettingValue.constructFromObject(data['platformSettingActiveSessionsMax']);
      }
      if (data.hasOwnProperty('logInspectionSettingEventRankSeverityLow')) {
        obj['logInspectionSettingEventRankSeverityLow'] = SettingValue.constructFromObject(data['logInspectionSettingEventRankSeverityLow']);
      }
      if (data.hasOwnProperty('platformSettingAzureSsoCertificate')) {
        obj['platformSettingAzureSsoCertificate'] = SettingValue.constructFromObject(data['platformSettingAzureSsoCertificate']);
      }
      if (data.hasOwnProperty('platformSettingSmtpUsername')) {
        obj['platformSettingSmtpUsername'] = SettingValue.constructFromObject(data['platformSettingSmtpUsername']);
      }
      if (data.hasOwnProperty('platformSettingEventForwardingSnsAdvancedConfigEnabled')) {
        obj['platformSettingEventForwardingSnsAdvancedConfigEnabled'] = SettingValue.constructFromObject(data['platformSettingEventForwardingSnsAdvancedConfigEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingInternetConnectivityTestInterval')) {
        obj['firewallSettingInternetConnectivityTestInterval'] = SettingValue.constructFromObject(data['firewallSettingInternetConnectivityTestInterval']);
      }
      if (data.hasOwnProperty('platformSettingWhoisUrl')) {
        obj['platformSettingWhoisUrl'] = SettingValue.constructFromObject(data['platformSettingWhoisUrl']);
      }
      if (data.hasOwnProperty('platformSettingDdanSourceOption')) {
        obj['platformSettingDdanSourceOption'] = SettingValue.constructFromObject(data['platformSettingDdanSourceOption']);
      }
      if (data.hasOwnProperty('platformSettingConnectedThreatDefenseControlManagerSuspiciousObjectListComparisonEnabled')) {
        obj['platformSettingConnectedThreatDefenseControlManagerSuspiciousObjectListComparisonEnabled'] = SettingValue.constructFromObject(data['platformSettingConnectedThreatDefenseControlManagerSuspiciousObjectListComparisonEnabled']);
      }
      if (data.hasOwnProperty('platformSettingExportedFileCharacterEncoding')) {
        obj['platformSettingExportedFileCharacterEncoding'] = SettingValue.constructFromObject(data['platformSettingExportedFileCharacterEncoding']);
      }
      if (data.hasOwnProperty('platformSettingUserSessionDurationMax')) {
        obj['platformSettingUserSessionDurationMax'] = SettingValue.constructFromObject(data['platformSettingUserSessionDurationMax']);
      }
      if (data.hasOwnProperty('platformSettingUpdateSoftwareAlternateUpdateServerUrls')) {
        obj['platformSettingUpdateSoftwareAlternateUpdateServerUrls'] = SettingValue.constructFromObject(data['platformSettingUpdateSoftwareAlternateUpdateServerUrls']);
      }
      if (data.hasOwnProperty('platformSettingRetainCountersDuration')) {
        obj['platformSettingRetainCountersDuration'] = SettingValue.constructFromObject(data['platformSettingRetainCountersDuration']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantRunComputerDiscoveryEnabled')) {
        obj['platformSettingPrimaryTenantAllowTenantRunComputerDiscoveryEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantRunComputerDiscoveryEnabled']);
      }
      if (data.hasOwnProperty('platformSettingSmartProtectionFeedbackInterval')) {
        obj['platformSettingSmartProtectionFeedbackInterval'] = SettingValue.constructFromObject(data['platformSettingSmartProtectionFeedbackInterval']);
      }
      if (data.hasOwnProperty('platformSettingSystemEventForwardingSnmpAddress')) {
        obj['platformSettingSystemEventForwardingSnmpAddress'] = SettingValue.constructFromObject(data['platformSettingSystemEventForwardingSnmpAddress']);
      }
      if (data.hasOwnProperty('platformSettingSmtpServerAddress')) {
        obj['platformSettingSmtpServerAddress'] = SettingValue.constructFromObject(data['platformSettingSmtpServerAddress']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantConfigureSiemEnabled')) {
        obj['platformSettingPrimaryTenantAllowTenantConfigureSiemEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantConfigureSiemEnabled']);
      }
      if (data.hasOwnProperty('platformSettingSmtpPassword')) {
        obj['platformSettingSmtpPassword'] = SettingValue.constructFromObject(data['platformSettingSmtpPassword']);
      }
      if (data.hasOwnProperty('platformSettingEventForwardingSnsConfigJson')) {
        obj['platformSettingEventForwardingSnsConfigJson'] = SettingValue.constructFromObject(data['platformSettingEventForwardingSnsConfigJson']);
      }
      if (data.hasOwnProperty('firewallSettingRetainEventDuration')) {
        obj['firewallSettingRetainEventDuration'] = SettingValue.constructFromObject(data['firewallSettingRetainEventDuration']);
      }
      if (data.hasOwnProperty('webReputationSettingEventRankRiskUntested')) {
        obj['webReputationSettingEventRankRiskUntested'] = SettingValue.constructFromObject(data['webReputationSettingEventRankRiskUntested']);
      }
      if (data.hasOwnProperty('platformSettingManagedDetectResponseUseProxyEnabled')) {
        obj['platformSettingManagedDetectResponseUseProxyEnabled'] = SettingValue.constructFromObject(data['platformSettingManagedDetectResponseUseProxyEnabled']);
      }
      if (data.hasOwnProperty('platformSettingEventForwardingSnsSecretKey')) {
        obj['platformSettingEventForwardingSnsSecretKey'] = SettingValue.constructFromObject(data['platformSettingEventForwardingSnsSecretKey']);
      }
      if (data.hasOwnProperty('platformSettingLogoBinaryImageImg')) {
        obj['platformSettingLogoBinaryImageImg'] = SettingValue.constructFromObject(data['platformSettingLogoBinaryImageImg']);
      }
      if (data.hasOwnProperty('platformSettingAwsManagerIdentitySecretKey')) {
        obj['platformSettingAwsManagerIdentitySecretKey'] = SettingValue.constructFromObject(data['platformSettingAwsManagerIdentitySecretKey']);
      }
      if (data.hasOwnProperty('webReputationSettingEventRankRiskHighlySuspicious')) {
        obj['webReputationSettingEventRankRiskHighlySuspicious'] = SettingValue.constructFromObject(data['webReputationSettingEventRankRiskHighlySuspicious']);
      }
      if (data.hasOwnProperty('platformSettingApiStatusMonitoringEnabled')) {
        obj['platformSettingApiStatusMonitoringEnabled'] = SettingValue.constructFromObject(data['platformSettingApiStatusMonitoringEnabled']);
      }
      if (data.hasOwnProperty('platformSettingSignInPageMessage')) {
        obj['platformSettingSignInPageMessage'] = SettingValue.constructFromObject(data['platformSettingSignInPageMessage']);
      }
      if (data.hasOwnProperty('platformSettingUserPasswordExpirySendEmailEnabled')) {
        obj['platformSettingUserPasswordExpirySendEmailEnabled'] = SettingValue.constructFromObject(data['platformSettingUserPasswordExpirySendEmailEnabled']);
      }
      if (data.hasOwnProperty('platformSettingUserSignInAttemptsAllowedNumber')) {
        obj['platformSettingUserSignInAttemptsAllowedNumber'] = SettingValue.constructFromObject(data['platformSettingUserSignInAttemptsAllowedNumber']);
      }
      if (data.hasOwnProperty('platformSettingDdanUseProxyEnabled')) {
        obj['platformSettingDdanUseProxyEnabled'] = SettingValue.constructFromObject(data['platformSettingDdanUseProxyEnabled']);
      }
      if (data.hasOwnProperty('platformSettingAgentInitiatedActivationEnabled')) {
        obj['platformSettingAgentInitiatedActivationEnabled'] = SettingValue.constructFromObject(data['platformSettingAgentInitiatedActivationEnabled']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantConfigureRememberMeOptionEnabled')) {
        obj['platformSettingPrimaryTenantAllowTenantConfigureRememberMeOptionEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantConfigureRememberMeOptionEnabled']);
      }
      if (data.hasOwnProperty('platformSettingSmartProtectionFeedbackBandwidthMaxKbytes')) {
        obj['platformSettingSmartProtectionFeedbackBandwidthMaxKbytes'] = SettingValue.constructFromObject(data['platformSettingSmartProtectionFeedbackBandwidthMaxKbytes']);
      }
      if (data.hasOwnProperty('firewallSettingEventRankSeverityPacketRejection')) {
        obj['firewallSettingEventRankSeverityPacketRejection'] = SettingValue.constructFromObject(data['firewallSettingEventRankSeverityPacketRejection']);
      }
      if (data.hasOwnProperty('platformSettingProxyManagerUpdateProxyId')) {
        obj['platformSettingProxyManagerUpdateProxyId'] = SettingValue.constructFromObject(data['platformSettingProxyManagerUpdateProxyId']);
      }
      if (data.hasOwnProperty('platformSettingManagedDetectResponseUsePrimaryTenantSettingsEnabled')) {
        obj['platformSettingManagedDetectResponseUsePrimaryTenantSettingsEnabled'] = SettingValue.constructFromObject(data['platformSettingManagedDetectResponseUsePrimaryTenantSettingsEnabled']);
      }
      if (data.hasOwnProperty('platformSettingEventForwardingSnsAccessKey')) {
        obj['platformSettingEventForwardingSnsAccessKey'] = SettingValue.constructFromObject(data['platformSettingEventForwardingSnsAccessKey']);
      }
      if (data.hasOwnProperty('platformSettingAgentInitiatedActivationSpecifyHostnameEnabled')) {
        obj['platformSettingAgentInitiatedActivationSpecifyHostnameEnabled'] = SettingValue.constructFromObject(data['platformSettingAgentInitiatedActivationSpecifyHostnameEnabled']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantSyncWithCloudAccountEnabled')) {
        obj['platformSettingPrimaryTenantAllowTenantSyncWithCloudAccountEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantSyncWithCloudAccountEnabled']);
      }
      if (data.hasOwnProperty('platformSettingConnectedThreatDefensesUsePrimaryTenantServerSettingsEnabled')) {
        obj['platformSettingConnectedThreatDefensesUsePrimaryTenantServerSettingsEnabled'] = SettingValue.constructFromObject(data['platformSettingConnectedThreatDefensesUsePrimaryTenantServerSettingsEnabled']);
      }
      if (data.hasOwnProperty('platformSettingInactiveAgentCleanupDuration')) {
        obj['platformSettingInactiveAgentCleanupDuration'] = SettingValue.constructFromObject(data['platformSettingInactiveAgentCleanupDuration']);
      }
      if (data.hasOwnProperty('platformSettingAgentInitiatedActivationDuplicateHostnameMode')) {
        obj['platformSettingAgentInitiatedActivationDuplicateHostnameMode'] = SettingValue.constructFromObject(data['platformSettingAgentInitiatedActivationDuplicateHostnameMode']);
      }
      if (data.hasOwnProperty('platformSettingVmwareNsxManagerNode')) {
        obj['platformSettingVmwareNsxManagerNode'] = SettingValue.constructFromObject(data['platformSettingVmwareNsxManagerNode']);
      }
      if (data.hasOwnProperty('platformSettingUserEnforceTermsAndConditionsTitle')) {
        obj['platformSettingUserEnforceTermsAndConditionsTitle'] = SettingValue.constructFromObject(data['platformSettingUserEnforceTermsAndConditionsTitle']);
      }
      if (data.hasOwnProperty('platformSettingPrimaryTenantAllowTenantAddVmwareVcenterEnabled')) {
        obj['platformSettingPrimaryTenantAllowTenantAddVmwareVcenterEnabled'] = SettingValue.constructFromObject(data['platformSettingPrimaryTenantAllowTenantAddVmwareVcenterEnabled']);
      }
      if (data.hasOwnProperty('platformSettingNewTenantDownloadSecurityUpdateEnabled')) {
        obj['platformSettingNewTenantDownloadSecurityUpdateEnabled'] = SettingValue.constructFromObject(data['platformSettingNewTenantDownloadSecurityUpdateEnabled']);
      }
      if (data.hasOwnProperty('platformSettingTenantProtectionUsageMonitoringComputerId3')) {
        obj['platformSettingTenantProtectionUsageMonitoringComputerId3'] = SettingValue.constructFromObject(data['platformSettingTenantProtectionUsageMonitoringComputerId3']);
      }
      if (data.hasOwnProperty('platformSettingAgentInitiatedActivationReactivateUnknownEnabled')) {
        obj['platformSettingAgentInitiatedActivationReactivateUnknownEnabled'] = SettingValue.constructFromObject(data['platformSettingAgentInitiatedActivationReactivateUnknownEnabled']);
      }
      if (data.hasOwnProperty('platformSettingTenantProtectionUsageMonitoringComputerId2')) {
        obj['platformSettingTenantProtectionUsageMonitoringComputerId2'] = SettingValue.constructFromObject(data['platformSettingTenantProtectionUsageMonitoringComputerId2']);
      }
      if (data.hasOwnProperty('platformSettingAgentInitiatedActivationPolicyId')) {
        obj['platformSettingAgentInitiatedActivationPolicyId'] = SettingValue.constructFromObject(data['platformSettingAgentInitiatedActivationPolicyId']);
      }
      if (data.hasOwnProperty('platformSettingTenantProtectionUsageMonitoringComputerId1')) {
        obj['platformSettingTenantProtectionUsageMonitoringComputerId1'] = SettingValue.constructFromObject(data['platformSettingTenantProtectionUsageMonitoringComputerId1']);
      }
      if (data.hasOwnProperty('platformSettingRetainAgentInstallersPerPlatformMax')) {
        obj['platformSettingRetainAgentInstallersPerPlatformMax'] = SettingValue.constructFromObject(data['platformSettingRetainAgentInstallersPerPlatformMax']);
      }
      if (data.hasOwnProperty('applicationControlSettingServeRulesetsFromRelaysEnabled')) {
        obj['applicationControlSettingServeRulesetsFromRelaysEnabled'] = SettingValue.constructFromObject(data['applicationControlSettingServeRulesetsFromRelaysEnabled']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingEventRankSeverityHigh')) {
        obj['integrityMonitoringSettingEventRankSeverityHigh'] = SettingValue.constructFromObject(data['integrityMonitoringSettingEventRankSeverityHigh']);
      }
      if (data.hasOwnProperty('platformSettingSamlRetainInactiveExternalAdministratorsDuration')) {
        obj['platformSettingSamlRetainInactiveExternalAdministratorsDuration'] = SettingValue.constructFromObject(data['platformSettingSamlRetainInactiveExternalAdministratorsDuration']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingRetainEventDuration')) {
        obj['intrusionPreventionSettingRetainEventDuration'] = SettingValue.constructFromObject(data['intrusionPreventionSettingRetainEventDuration']);
      }
      if (data.hasOwnProperty('platformSettingHttpPublicKeyPinPolicyReportOnlyEnabled')) {
        obj['platformSettingHttpPublicKeyPinPolicyReportOnlyEnabled'] = SettingValue.constructFromObject(data['platformSettingHttpPublicKeyPinPolicyReportOnlyEnabled']);
      }
      if (data.hasOwnProperty('platformSettingSamlServiceProviderName')) {
        obj['platformSettingSamlServiceProviderName'] = SettingValue.constructFromObject(data['platformSettingSamlServiceProviderName']);
      }
      if (data.hasOwnProperty('firewallSettingInternetConnectivityTestUrl')) {
        obj['firewallSettingInternetConnectivityTestUrl'] = SettingValue.constructFromObject(data['firewallSettingInternetConnectivityTestUrl']);
      }
      if (data.hasOwnProperty('platformSettingSamlServiceProviderCertificateExpiryWarningDays')) {
        obj['platformSettingSamlServiceProviderCertificateExpiryWarningDays'] = SettingValue.constructFromObject(data['platformSettingSamlServiceProviderCertificateExpiryWarningDays']);
      }
      if (data.hasOwnProperty('platformSettingProxyAgentUpdateProxyId')) {
        obj['platformSettingProxyAgentUpdateProxyId'] = SettingValue.constructFromObject(data['platformSettingProxyAgentUpdateProxyId']);
      }
      if (data.hasOwnProperty('platformSettingDdanAutoSubmissionEnabled')) {
        obj['platformSettingDdanAutoSubmissionEnabled'] = SettingValue.constructFromObject(data['platformSettingDdanAutoSubmissionEnabled']);
      }
      if (data.hasOwnProperty('platformSettingDdanManualSourceApiKey')) {
        obj['platformSettingDdanManualSourceApiKey'] = SettingValue.constructFromObject(data['platformSettingDdanManualSourceApiKey']);
      }
      if (data.hasOwnProperty('platformSettingSamlServiceProviderEntityId')) {
        obj['platformSettingSamlServiceProviderEntityId'] = SettingValue.constructFromObject(data['platformSettingSamlServiceProviderEntityId']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingEventRankSeverityFilterError')) {
        obj['intrusionPreventionSettingEventRankSeverityFilterError'] = SettingValue.constructFromObject(data['intrusionPreventionSettingEventRankSeverityFilterError']);
      }
      if (data.hasOwnProperty('platformSettingUpgradeOnActivationEnabled')) {
        obj['platformSettingUpgradeOnActivationEnabled'] = SettingValue.constructFromObject(data['platformSettingUpgradeOnActivationEnabled']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingEventRankSeverityFilterHigh')) {
        obj['intrusionPreventionSettingEventRankSeverityFilterHigh'] = SettingValue.constructFromObject(data['intrusionPreventionSettingEventRankSeverityFilterHigh']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingEventRankSeverityLow')) {
        obj['integrityMonitoringSettingEventRankSeverityLow'] = SettingValue.constructFromObject(data['integrityMonitoringSettingEventRankSeverityLow']);
      }
    }
    return obj;
  }

  /**
   * Warn when a SAML identity provider certificate will expire within (days)
   * @member {module:model/SettingValue} platformSettingSamlIdentityProviderCertificateExpiryWarningDays
   */
  exports.prototype['platformSettingSamlIdentityProviderCertificateExpiryWarningDays'] = undefined;
  /**
   * Allow Agents/Appliances to download security updates when Deep Security Manager is not accessible
   * @member {module:model/SettingValue} platformSettingUpdateAgentSecurityOnMissingDeepSecurityManagerEnabled
   */
  exports.prototype['platformSettingUpdateAgentSecurityOnMissingDeepSecurityManagerEnabled'] = undefined;
  /**
   * Server URL (ex: \"https://[server]/\")
   * @member {module:model/SettingValue} platformSettingDdanManualSourceServerUrl
   */
  exports.prototype['platformSettingDdanManualSourceServerUrl'] = undefined;
  /**
   * Load Balancer Manager Port
   * @member {module:model/SettingValue} platformSettingLoadBalancerManagerPort
   */
  exports.prototype['platformSettingLoadBalancerManagerPort'] = undefined;
  /**
   * Feedback Interval by threats
   * @member {module:model/SettingValue} platformSettingSmartProtectionFeedbackThreatDetectionsThreshold
   */
  exports.prototype['platformSettingSmartProtectionFeedbackThreatDetectionsThreshold'] = undefined;
  /**
   * Allow Tenants to run \"Port Scan\" (directly and as a Scheduled Task)
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantRunPortScanEnabled
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantRunPortScanEnabled'] = undefined;
  /**
   * Medium
   * @member {module:model/SettingValue} intrusionPreventionSettingEventRankSeverityFilterMedium
   */
  exports.prototype['intrusionPreventionSettingEventRankSeverityFilterMedium'] = undefined;
  /**
   * Regular Expression for returned content used to confirm Intranet Connectivity
   * @member {module:model/SettingValue} firewallSettingIntranetConnectivityTestExpectedContentRegex
   */
  exports.prototype['firewallSettingIntranetConnectivityTestExpectedContentRegex'] = undefined;
  /**
   * Publish Events to AWS Simple Notification Service
   * @member {module:model/SettingValue} platformSettingEventForwardingSnsEnabled
   */
  exports.prototype['platformSettingEventForwardingSnsEnabled'] = undefined;
  /**
   * Automatically revoke Primary Tenant access after
   * @member {module:model/SettingValue} platformSettingTenantAutoRevokeImpersonationByPrimaryTenantTimeout
   */
  exports.prototype['platformSettingTenantAutoRevokeImpersonationByPrimaryTenantTimeout'] = undefined;
  /**
   * Blocked By Administrator
   * @member {module:model/SettingValue} webReputationSettingEventRankRiskBlockedByAdministratorRank
   */
  exports.prototype['webReputationSettingEventRankRiskBlockedByAdministratorRank'] = undefined;
  /**
   * All options on the \"Storage\" Tab
   * @member {module:model/SettingValue} platformSettingPrimaryTenantLockAndHideTenantStorageTabEnabled
   */
  exports.prototype['platformSettingPrimaryTenantLockAndHideTenantStorageTabEnabled'] = undefined;
  /**
   * Email Recipients
   * @member {module:model/SettingValue} antiMalwareSettingEventEmailRecipients
   */
  exports.prototype['antiMalwareSettingEventEmailRecipients'] = undefined;
  /**
   * Allow Tenants to use the Relays in my \"Default Relay Group\"
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantUseDefaultRelayGroupEnabled
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantUseDefaultRelayGroupEnabled'] = undefined;
  /**
   * Enable HTTP Strict Transport Security
   * @member {module:model/SettingValue} platformSettingHttpStrictTransportEnabled
   */
  exports.prototype['platformSettingHttpStrictTransportEnabled'] = undefined;
  /**
   * URL for testing Intranet Connectivity Status
   * @member {module:model/SettingValue} firewallSettingIntranetConnectivityTestUrl
   */
  exports.prototype['firewallSettingIntranetConnectivityTestUrl'] = undefined;
  /**
   * Allow Tenants to configure SNS settings
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantConfigureSnsEnabled
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantConfigureSnsEnabled'] = undefined;
  /**
   * Use the Primary Tenant Relay Group as my Default Relay Group
   * @member {module:model/SettingValue} platformSettingTenantUseDefaultRelayGroupFromPrimaryTenantEnabled
   */
  exports.prototype['platformSettingTenantUseDefaultRelayGroupFromPrimaryTenantEnabled'] = undefined;
  /**
   * Exported Diagnostic Package Language
   * @member {module:model/SettingValue} platformSettingExportedDiagnosticPackageLocale
   */
  exports.prototype['platformSettingExportedDiagnosticPackageLocale'] = undefined;
  /**
   * Critical
   * @member {module:model/SettingValue} intrusionPreventionSettingEventRankSeverityFilterCritical
   */
  exports.prototype['intrusionPreventionSettingEventRankSeverityFilterCritical'] = undefined;
  /**
   * Automatically download updates to imported software
   * @member {module:model/SettingValue} platformSettingUpdateImportedSoftwareAutoDownloadEnabled
   */
  exports.prototype['platformSettingUpdateImportedSoftwareAutoDownloadEnabled'] = undefined;
  /**
   * Demo Mode Enabled
   * @member {module:model/SettingValue} platformSettingDemoModeEnabled
   */
  exports.prototype['platformSettingDemoModeEnabled'] = undefined;
  /**
   * List of Terms And Conditions
   * @member {module:model/SettingValue} platformSettingUserEnforceTermsAndConditionsMessage
   */
  exports.prototype['platformSettingUserEnforceTermsAndConditionsMessage'] = undefined;
  /**
   * Company GUID
   * @member {module:model/SettingValue} platformSettingManagedDetectResponseCompanyGuid
   */
  exports.prototype['platformSettingManagedDetectResponseCompanyGuid'] = undefined;
  /**
   * Alert Email Address - The email address to which all alert emails should be sent
   * @member {module:model/SettingValue} platformSettingAlertDefaultEmailAddress
   */
  exports.prototype['platformSettingAlertDefaultEmailAddress'] = undefined;
  /**
   * Reactivate cloned Agents
   * @member {module:model/SettingValue} platformSettingAgentInitiatedActivationReactivateClonedEnabled
   */
  exports.prototype['platformSettingAgentInitiatedActivationReactivateClonedEnabled'] = undefined;
  /**
   * Server URL (ex: \"https://[server]/\")
   * @member {module:model/SettingValue} platformSettingManagedDetectResponseServerUrl
   */
  exports.prototype['platformSettingManagedDetectResponseServerUrl'] = undefined;
  /**
   * Allow Tenants to use Primary Tenant's Managed Detection and Response settings.
   * @member {module:model/SettingValue} platformSettingPrimaryTenantShareManagedDetectResponsesEnabled
   */
  exports.prototype['platformSettingPrimaryTenantShareManagedDetectResponsesEnabled'] = undefined;
  /**
   * SAML Service Provider Certificate
   * @member {module:model/SettingValue} platformSettingSamlServiceProviderCertificate
   */
  exports.prototype['platformSettingSamlServiceProviderCertificate'] = undefined;
  /**
   * Forward System Events to a remote computer (via Syslog) using configuration
   * @member {module:model/SettingValue} platformSettingSyslogConfigId
   */
  exports.prototype['platformSettingSyslogConfigId'] = undefined;
  /**
   * STARTTLS
   * @member {module:model/SettingValue} platformSettingSmtpStartTlsEnabled
   */
  exports.prototype['platformSettingSmtpStartTlsEnabled'] = undefined;
  /**
   * User password requires both letters and numbers
   * @member {module:model/SettingValue} platformSettingUserPasswordRequireLettersAndNumbersEnabled
   */
  exports.prototype['platformSettingUserPasswordRequireLettersAndNumbersEnabled'] = undefined;
  /**
   * Allow Tenants to synchronize with LDAP Directories
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantSynchronizeLdapDirectoriesEnabled
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantSynchronizeLdapDirectoriesEnabled'] = undefined;
  /**
   * Load Balancer Relay Port
   * @member {module:model/SettingValue} platformSettingLoadBalancerRelayPort
   */
  exports.prototype['platformSettingLoadBalancerRelayPort'] = undefined;
  /**
   * Enable the MDR service
   * @member {module:model/SettingValue} platformSettingManagedDetectResponseEnabled
   */
  exports.prototype['platformSettingManagedDetectResponseEnabled'] = undefined;
  /**
   * Automatically apply Rule Updates to Policies
   * @member {module:model/SettingValue} platformSettingUpdateRulesPolicyAutoApplyEnabled
   */
  exports.prototype['platformSettingUpdateRulesPolicyAutoApplyEnabled'] = undefined;
  /**
   * Show the \"Forgot Password?\" option
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantConfigureForgotPasswordEnabled
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantConfigureForgotPasswordEnabled'] = undefined;
  /**
   * User password cannot match username or username spelled backward
   * @member {module:model/SettingValue} platformSettingUserPasswordRequireNotSameAsUsernameEnabled
   */
  exports.prototype['platformSettingUserPasswordRequireNotSameAsUsernameEnabled'] = undefined;
  /**
   * Medium
   * @member {module:model/SettingValue} logInspectionSettingEventRankSeverityMedium
   */
  exports.prototype['logInspectionSettingEventRankSeverityMedium'] = undefined;
  /**
   * Automatically delete Anti-Malware Events older than
   * @member {module:model/SettingValue} antiMalwareSettingRetainEventDuration
   */
  exports.prototype['antiMalwareSettingRetainEventDuration'] = undefined;
  /**
   * Allow Agents/Appliances to download security updates directly from Primary Security Update Source if Relays are not accessible
   * @member {module:model/SettingValue} platformSettingUpdateAgentSecurityContactPrimarySourceOnMissingRelayEnabled
   */
  exports.prototype['platformSettingUpdateAgentSecurityContactPrimarySourceOnMissingRelayEnabled'] = undefined;
  /**
   * Log Only
   * @member {module:model/SettingValue} firewallSettingEventRankSeverityLogOnly
   */
  exports.prototype['firewallSettingEventRankSeverityLogOnly'] = undefined;
  /**
   * Data Privacy options on the \"Agents\" Tab
   * @member {module:model/SettingValue} platformSettingPrimaryTenantLockAndHideTenantDataPrivacyOptionEnabled
   */
  exports.prototype['platformSettingPrimaryTenantLockAndHideTenantDataPrivacyOptionEnabled'] = undefined;
  /**
   * Automatically delete Application Control Events older than
   * @member {module:model/SettingValue} applicationControlSettingRetainEventDuration
   */
  exports.prototype['applicationControlSettingRetainEventDuration'] = undefined;
  /**
   * SOAP web service API Enabled
   * @member {module:model/SettingValue} platformSettingApiSoapWebServiceEnabled
   */
  exports.prototype['platformSettingApiSoapWebServiceEnabled'] = undefined;
  /**
   * SAML Service Provider Private Key
   * @member {module:model/SettingValue} platformSettingSamlServiceProviderPrivateKey
   */
  exports.prototype['platformSettingSamlServiceProviderPrivateKey'] = undefined;
  /**
   * UDP port to which events should be sent
   * @member {module:model/SettingValue} platformSettingSystemEventForwardingSnmpPort
   */
  exports.prototype['platformSettingSystemEventForwardingSnmpPort'] = undefined;
  /**
   * Deny
   * @member {module:model/SettingValue} firewallSettingEventRankSeverityDeny
   */
  exports.prototype['firewallSettingEventRankSeverityDeny'] = undefined;
  /**
   * Low
   * @member {module:model/SettingValue} intrusionPreventionSettingEventRankSeverityFilterLow
   */
  exports.prototype['intrusionPreventionSettingEventRankSeverityFilterLow'] = undefined;
  /**
   * Allow Tenants to control access from the Primary Tenant
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantControlImpersonationEnabled
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantControlImpersonationEnabled'] = undefined;
  /**
   * CPU Usage Level
   * @member {module:model/SettingValue} platformSettingRecommendationCpuUsageLevel
   */
  exports.prototype['platformSettingRecommendationCpuUsageLevel'] = undefined;
  /**
   * Service Token
   * @member {module:model/SettingValue} platformSettingManagedDetectResponseServiceToken
   */
  exports.prototype['platformSettingManagedDetectResponseServiceToken'] = undefined;
  /**
   * Load Balancer Heartbeat Hostname
   * @member {module:model/SettingValue} platformSettingLoadBalancerHeartbeatAddress
   */
  exports.prototype['platformSettingLoadBalancerHeartbeatAddress'] = undefined;
  /**
   * Report only
   * @member {module:model/SettingValue} platformSettingContentSecurityPolicyReportOnlyEnabled
   */
  exports.prototype['platformSettingContentSecurityPolicyReportOnlyEnabled'] = undefined;
  /**
   * Automatically delete Log Inspection Events older than
   * @member {module:model/SettingValue} logInspectionSettingRetainEventDuration
   */
  exports.prototype['logInspectionSettingRetainEventDuration'] = undefined;
  /**
   * Automatically revoke Primary Tenant access after
   * @member {module:model/SettingValue} platformSettingTenantAutoRevokeImpersonationByPrimaryTenantEnabled
   */
  exports.prototype['platformSettingTenantAutoRevokeImpersonationByPrimaryTenantEnabled'] = undefined;
  /**
   * Email Template
   * @member {module:model/SettingValue} antiMalwareSettingEventEmailBodyTemplate
   */
  exports.prototype['antiMalwareSettingEventEmailBodyTemplate'] = undefined;
  /**
   * Number of older Rule Updates to keep
   * @member {module:model/SettingValue} platformSettingRetainSecurityUpdatesMax
   */
  exports.prototype['platformSettingRetainSecurityUpdatesMax'] = undefined;
  /**
   * Suspicious Object List Source
   * @member {module:model/SettingValue} platformSettingConnectedThreatDefenseControlManagerSourceOption
   */
  exports.prototype['platformSettingConnectedThreatDefenseControlManagerSourceOption'] = undefined;
  /**
   * Anti-Malware Email Notifications Enabled
   * @member {module:model/SettingValue} antiMalwareSettingEventEmailEnabled
   */
  exports.prototype['antiMalwareSettingEventEmailEnabled'] = undefined;
  /**
   * Allow Relays to download software updates from Trend Micro Download Center when Deep Security Manager is not accessible
   * @member {module:model/SettingValue} platformSettingUpdateAgentSoftwareUseDownloadCenterOnMissingDeepSecurityManagerEnabled
   */
  exports.prototype['platformSettingUpdateAgentSoftwareUseDownloadCenterOnMissingDeepSecurityManagerEnabled'] = undefined;
  /**
   * Perform ongoing Recommendation Scans
   * @member {module:model/SettingValue} platformSettingRecommendationOngoingScansEnabled
   */
  exports.prototype['platformSettingRecommendationOngoingScansEnabled'] = undefined;
  /**
   * Agent activation token:
   * @member {module:model/SettingValue} platformSettingAgentInitiatedActivationToken
   */
  exports.prototype['platformSettingAgentInitiatedActivationToken'] = undefined;
  /**
   * User password minimum length
   * @member {module:model/SettingValue} platformSettingUserPasswordLengthMin
   */
  exports.prototype['platformSettingUserPasswordLengthMin'] = undefined;
  /**
   * Primary Database Server State
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantDatabaseState
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantDatabaseState'] = undefined;
  /**
   * Use Instance Role
   * @member {module:model/SettingValue} platformSettingAwsManagerIdentityUseInstanceRoleEnabled
   */
  exports.prototype['platformSettingAwsManagerIdentityUseInstanceRoleEnabled'] = undefined;
  /**
   * Content security policy
   * @member {module:model/SettingValue} platformSettingContentSecurityPolicy
   */
  exports.prototype['platformSettingContentSecurityPolicy'] = undefined;
  /**
   * Enable Product Usage Data Collection
   * @member {module:model/SettingValue} platformSettingProductUsageDataCollectionEnabled
   */
  exports.prototype['platformSettingProductUsageDataCollectionEnabled'] = undefined;
  /**
   * Length of time an Update can be pending before raising an Alert
   * @member {module:model/SettingValue} platformSettingAlertAgentUpdatePendingThreshold
   */
  exports.prototype['platformSettingAlertAgentUpdatePendingThreshold'] = undefined;
  /**
   * User password requires non-alphanumeric characters
   * @member {module:model/SettingValue} platformSettingUserPasswordRequireSpecialCharactersEnabled
   */
  exports.prototype['platformSettingUserPasswordRequireSpecialCharactersEnabled'] = undefined;
  /**
   * Upon deployment, update Deep Security Virtual Appliances to
   * @member {module:model/SettingValue} platformSettingUpdateApplianceDefaultAgentVersion
   */
  exports.prototype['platformSettingUpdateApplianceDefaultAgentVersion'] = undefined;
  /**
   * Forward System Events to a remote computer (via SNMP)
   * @member {module:model/SettingValue} platformSettingSystemEventForwardingSnmpEnabled
   */
  exports.prototype['platformSettingSystemEventForwardingSnmpEnabled'] = undefined;
  /**
   * \"Bounce\" email address (optional) - The email address to which delivery failure notifications should be sent
   * @member {module:model/SettingValue} platformSettingSmtpBounceEmailAddress
   */
  exports.prototype['platformSettingSmtpBounceEmailAddress'] = undefined;
  /**
   * Allow supported 8.0 and 9.0 Agents to be updated
   * @member {module:model/SettingValue} platformSettingUpdateRelaySecuritySupportAgent9AndEarlierEnabled
   */
  exports.prototype['platformSettingUpdateRelaySecuritySupportAgent9AndEarlierEnabled'] = undefined;
  /**
   * Use Proxy when accessing MDR server
   * @member {module:model/SettingValue} platformSettingManagedDetectResponseProxyId
   */
  exports.prototype['platformSettingManagedDetectResponseProxyId'] = undefined;
  /**
   * Delete Agents that have been inactive for:
   * @member {module:model/SettingValue} platformSettingInactiveAgentCleanupEnabled
   */
  exports.prototype['platformSettingInactiveAgentCleanupEnabled'] = undefined;
  /**
   * Load Balancer Relay Hostname
   * @member {module:model/SettingValue} platformSettingLoadBalancerRelayAddress
   */
  exports.prototype['platformSettingLoadBalancerRelayAddress'] = undefined;
  /**
   * HTTP public key pin policy
   * @member {module:model/SettingValue} platformSettingHttpPublicKeyPinPolicy
   */
  exports.prototype['platformSettingHttpPublicKeyPinPolicy'] = undefined;
  /**
   * Session idle timeout
   * @member {module:model/SettingValue} platformSettingUserSessionIdleTimeout
   */
  exports.prototype['platformSettingUserSessionIdleTimeout'] = undefined;
  /**
   * Email Subject Text
   * @member {module:model/SettingValue} antiMalwareSettingEventEmailSubject
   */
  exports.prototype['antiMalwareSettingEventEmailSubject'] = undefined;
  /**
   * When accessing Apex Central, use proxy:
   * @member {module:model/SettingValue} platformSettingConnectedThreatDefenseControlManagerUseProxyEnabled
   */
  exports.prototype['platformSettingConnectedThreatDefenseControlManagerUseProxyEnabled'] = undefined;
  /**
   * User must agree to the terms and conditions
   * @member {module:model/SettingValue} platformSettingUserEnforceTermsAndConditionsEnabled
   */
  exports.prototype['platformSettingUserEnforceTermsAndConditionsEnabled'] = undefined;
  /**
   * Access Key - The Access Key of an AWS User used for the manager identity
   * @member {module:model/SettingValue} platformSettingAwsManagerIdentityAccessKey
   */
  exports.prototype['platformSettingAwsManagerIdentityAccessKey'] = undefined;
  /**
   * Use Proxy when accessing Apex Central
   * @member {module:model/SettingValue} platformSettingConnectedThreatDefenseControlManagerProxyId
   */
  exports.prototype['platformSettingConnectedThreatDefenseControlManagerProxyId'] = undefined;
  /**
   * Allow Primary Tenant access to my Deep Security Environment
   * @member {module:model/SettingValue} platformSettingTenantAllowImpersonationByPrimaryTenantEnabled
   */
  exports.prototype['platformSettingTenantAllowImpersonationByPrimaryTenantEnabled'] = undefined;
  /**
   * Server URL (ex: \"https://[server]/webapp\")
   * @member {module:model/SettingValue} platformSettingConnectedThreatDefenseControlManagerManualSourceServerUrl
   */
  exports.prototype['platformSettingConnectedThreatDefenseControlManagerManualSourceServerUrl'] = undefined;
  /**
   * User password requires both upper and lower case characters
   * @member {module:model/SettingValue} platformSettingUserPasswordRequireMixedCaseEnabled
   */
  exports.prototype['platformSettingUserPasswordRequireMixedCaseEnabled'] = undefined;
  /**
   * Send suspicious file signatures along with feedback
   * @member {module:model/SettingValue} platformSettingSmartProtectionFeedbackForSuspiciousFileEnabled
   */
  exports.prototype['platformSettingSmartProtectionFeedbackForSuspiciousFileEnabled'] = undefined;
  /**
   * Allow Tenants to configure SNMP settings
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantConfigureSnmpEnabled
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantConfigureSnmpEnabled'] = undefined;
  /**
   * Your industry (optional):
   * @member {module:model/SettingValue} platformSettingSmartProtectionFeedbackIndustryType
   */
  exports.prototype['platformSettingSmartProtectionFeedbackIndustryType'] = undefined;
  /**
   * Automatically delete Web Reputation Events older than
   * @member {module:model/SettingValue} webReputationSettingRetainEventDuration
   */
  exports.prototype['webReputationSettingRetainEventDuration'] = undefined;
  /**
   * Automatically delete Server Logs older than
   * @member {module:model/SettingValue} platformSettingRetainServerLogDuration
   */
  exports.prototype['platformSettingRetainServerLogDuration'] = undefined;
  /**
   * Medium
   * @member {module:model/SettingValue} integrityMonitoringSettingEventRankSeverityMedium
   */
  exports.prototype['integrityMonitoringSettingEventRankSeverityMedium'] = undefined;
  /**
   * Deep Security Manager (Cloud Accounts - HTTP Protocol Only):
   * @member {module:model/SettingValue} platformSettingProxyManagerCloudProxyId
   */
  exports.prototype['platformSettingProxyManagerCloudProxyId'] = undefined;
  /**
   * Download Patterns for all Regions
   * @member {module:model/SettingValue} platformSettingUpdateRelaySecurityAllRegionsPatternsDownloadEnabled
   */
  exports.prototype['platformSettingUpdateRelaySecurityAllRegionsPatternsDownloadEnabled'] = undefined;
  /**
   * Enable submission of suspicious files to Deep Discovery Analyzer
   * @member {module:model/SettingValue} platformSettingDdanSubmissionEnabled
   */
  exports.prototype['platformSettingDdanSubmissionEnabled'] = undefined;
  /**
   * Suspicious
   * @member {module:model/SettingValue} webReputationSettingEventRankRiskSuspicious
   */
  exports.prototype['webReputationSettingEventRankRiskSuspicious'] = undefined;
  /**
   * Critical
   * @member {module:model/SettingValue} integrityMonitoringSettingEventRankSeverityCritical
   */
  exports.prototype['integrityMonitoringSettingEventRankSeverityCritical'] = undefined;
  /**
   * \"From\" email address - The email address from which outgoing emails should be sent
   * @member {module:model/SettingValue} platformSettingSmtpFromEmailAddress
   */
  exports.prototype['platformSettingSmtpFromEmailAddress'] = undefined;
  /**
   * Global Firewall Stateful Configuration
   * @member {module:model/SettingValue} firewallSettingGlobalStatefulConfigId
   */
  exports.prototype['firewallSettingGlobalStatefulConfigId'] = undefined;
  /**
   * SNS Topic ARN
   * @member {module:model/SettingValue} platformSettingEventForwardingSnsTopicArn
   */
  exports.prototype['platformSettingEventForwardingSnsTopicArn'] = undefined;
  /**
   * Regular Expression for returned content used to confirm Connectivity
   * @member {module:model/SettingValue} firewallSettingInternetConnectivityTestExpectedContentRegex
   */
  exports.prototype['firewallSettingInternetConnectivityTestExpectedContentRegex'] = undefined;
  /**
   * API Key
   * @member {module:model/SettingValue} platformSettingConnectedThreatDefenseControlManagerManualSourceApiKey
   */
  exports.prototype['platformSettingConnectedThreatDefenseControlManagerManualSourceApiKey'] = undefined;
  /**
   * Load Balancer Manager Hostname
   * @member {module:model/SettingValue} platformSettingLoadBalancerManagerAddress
   */
  exports.prototype['platformSettingLoadBalancerManagerAddress'] = undefined;
  /**
   * Relay Update Source
   * @member {module:model/SettingValue} platformSettingUpdateSecurityPrimarySourceMode
   */
  exports.prototype['platformSettingUpdateSecurityPrimarySourceMode'] = undefined;
  /**
   * Allow Tenants to use the Primary Tenant's Trend Micro Apex Central and Deep Discovery Analyzer Server settings.
   * @member {module:model/SettingValue} platformSettingPrimaryTenantShareConnectedThreatDefensesEnabled
   */
  exports.prototype['platformSettingPrimaryTenantShareConnectedThreatDefensesEnabled'] = undefined;
  /**
   * Dangerous
   * @member {module:model/SettingValue} webReputationSettingEventRankRiskDangerous
   */
  exports.prototype['webReputationSettingEventRankRiskDangerous'] = undefined;
  /**
   * Load Balancer Heartbeat Port
   * @member {module:model/SettingValue} platformSettingLoadBalancerHeartbeatPort
   */
  exports.prototype['platformSettingLoadBalancerHeartbeatPort'] = undefined;
  /**
   * Hide unlicensed Protection Modules for new Users
   * @member {module:model/SettingValue} platformSettingUserHideUnlicensedModulesEnabled
   */
  exports.prototype['platformSettingUserHideUnlicensedModulesEnabled'] = undefined;
  /**
   * Allow packet data capture on encrypted traffic (SSL)
   * @member {module:model/SettingValue} platformSettingCaptureEncryptedTrafficEnabled
   */
  exports.prototype['platformSettingCaptureEncryptedTrafficEnabled'] = undefined;
  /**
   * Automatically delete System Events older than
   * @member {module:model/SettingValue} platformSettingRetainSystemEventDuration
   */
  exports.prototype['platformSettingRetainSystemEventDuration'] = undefined;
  /**
   * User password expires
   * @member {module:model/SettingValue} platformSettingUserPasswordExpiry
   */
  exports.prototype['platformSettingUserPasswordExpiry'] = undefined;
  /**
   * Enable Trend Micro Smart Feedback (recommended)
   * @member {module:model/SettingValue} platformSettingSmartProtectionFeedbackEnabled
   */
  exports.prototype['platformSettingSmartProtectionFeedbackEnabled'] = undefined;
  /**
   * Automatically delete Integrity Monitoring Events older than
   * @member {module:model/SettingValue} integrityMonitoringSettingRetainEventDuration
   */
  exports.prototype['integrityMonitoringSettingRetainEventDuration'] = undefined;
  /**
   * Allow Tenants to use the \"Run Script\" Scheduled Task
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantUseScheduledRunScriptTaskEnabled
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantUseScheduledRunScriptTaskEnabled'] = undefined;
  /**
   * Critical
   * @member {module:model/SettingValue} logInspectionSettingEventRankSeverityCritical
   */
  exports.prototype['logInspectionSettingEventRankSeverityCritical'] = undefined;
  /**
   * All options on the \"SMTP\" Tab
   * @member {module:model/SettingValue} platformSettingPrimaryTenantLockAndHideTenantSmtpTabEnabled
   */
  exports.prototype['platformSettingPrimaryTenantLockAndHideTenantSmtpTabEnabled'] = undefined;
  /**
   * Use Proxy when accessing Deep Discovery Analyzer
   * @member {module:model/SettingValue} platformSettingDdanProxyId
   */
  exports.prototype['platformSettingDdanProxyId'] = undefined;
  /**
   * Agent-Initiated Activation IP List
   * @member {module:model/SettingValue} platformSettingAgentInitiatedActivationWithinIpListId
   */
  exports.prototype['platformSettingAgentInitiatedActivationWithinIpListId'] = undefined;
  /**
   * URL
   * @member {module:model/SettingValue} platformSettingUpdateSecurityPrimarySourceUrl
   */
  exports.prototype['platformSettingUpdateSecurityPrimarySourceUrl'] = undefined;
  /**
   * Allow Appliance protection of vCloud VMs
   * @member {module:model/SettingValue} platformSettingAgentlessVcloudProtectionEnabled
   */
  exports.prototype['platformSettingAgentlessVcloudProtectionEnabled'] = undefined;
  /**
   * Action when concurrent session limit is exceeded
   * @member {module:model/SettingValue} platformSettingActiveSessionsMaxExceededAction
   */
  exports.prototype['platformSettingActiveSessionsMaxExceededAction'] = undefined;
  /**
   * Update the \"Hostname\" entry if an IP is used as a hostname and a change in IP is detected on the computer after Agent/Appliance-initiated communication or discovery
   * @member {module:model/SettingValue} platformSettingUpdateHostnameOnIpChangeEnabled
   */
  exports.prototype['platformSettingUpdateHostnameOnIpChangeEnabled'] = undefined;
  /**
   * High
   * @member {module:model/SettingValue} logInspectionSettingEventRankSeverityHigh
   */
  exports.prototype['logInspectionSettingEventRankSeverityHigh'] = undefined;
  /**
   * Mail server requires authentication
   * @member {module:model/SettingValue} platformSettingSmtpRequiresAuthenticationEnabled
   */
  exports.prototype['platformSettingSmtpRequiresAuthenticationEnabled'] = undefined;
  /**
   * Number of concurrent sessions allowed per User
   * @member {module:model/SettingValue} platformSettingActiveSessionsMax
   */
  exports.prototype['platformSettingActiveSessionsMax'] = undefined;
  /**
   * Low
   * @member {module:model/SettingValue} logInspectionSettingEventRankSeverityLow
   */
  exports.prototype['logInspectionSettingEventRankSeverityLow'] = undefined;
  /**
   * Azure resource provider certificate for SSO
   * @member {module:model/SettingValue} platformSettingAzureSsoCertificate
   */
  exports.prototype['platformSettingAzureSsoCertificate'] = undefined;
  /**
   * SMTP username
   * @member {module:model/SettingValue} platformSettingSmtpUsername
   */
  exports.prototype['platformSettingSmtpUsername'] = undefined;
  /**
   * AWS SNS Advanced Configuration
   * @member {module:model/SettingValue} platformSettingEventForwardingSnsAdvancedConfigEnabled
   */
  exports.prototype['platformSettingEventForwardingSnsAdvancedConfigEnabled'] = undefined;
  /**
   * Test Interval
   * @member {module:model/SettingValue} firewallSettingInternetConnectivityTestInterval
   */
  exports.prototype['firewallSettingInternetConnectivityTestInterval'] = undefined;
  /**
   * Whois URL - The full URL to a Whois lookup with the IP represented as [IP]
   * @member {module:model/SettingValue} platformSettingWhoisUrl
   */
  exports.prototype['platformSettingWhoisUrl'] = undefined;
  /**
   * Deep Discovery Analyzer Source
   * @member {module:model/SettingValue} platformSettingDdanSourceOption
   */
  exports.prototype['platformSettingDdanSourceOption'] = undefined;
  /**
   * Compare objects against Suspicious Object List
   * @member {module:model/SettingValue} platformSettingConnectedThreatDefenseControlManagerSuspiciousObjectListComparisonEnabled
   */
  exports.prototype['platformSettingConnectedThreatDefenseControlManagerSuspiciousObjectListComparisonEnabled'] = undefined;
  /**
   * Exported file Character Encoding
   * @member {module:model/SettingValue} platformSettingExportedFileCharacterEncoding
   */
  exports.prototype['platformSettingExportedFileCharacterEncoding'] = undefined;
  /**
   * Maximum session duration
   * @member {module:model/SettingValue} platformSettingUserSessionDurationMax
   */
  exports.prototype['platformSettingUserSessionDurationMax'] = undefined;
  /**
   * Alternate Software Update Web Server(s)
   * @member {module:model/SettingValue} platformSettingUpdateSoftwareAlternateUpdateServerUrls
   */
  exports.prototype['platformSettingUpdateSoftwareAlternateUpdateServerUrls'] = undefined;
  /**
   * Automatically delete Counters older than
   * @member {module:model/SettingValue} platformSettingRetainCountersDuration
   */
  exports.prototype['platformSettingRetainCountersDuration'] = undefined;
  /**
   * Allow Tenants to run \"Computer Discovery\" (directly and as a Scheduled Task)
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantRunComputerDiscoveryEnabled
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantRunComputerDiscoveryEnabled'] = undefined;
  /**
   * Feedback Interval (min)
   * @member {module:model/SettingValue} platformSettingSmartProtectionFeedbackInterval
   */
  exports.prototype['platformSettingSmartProtectionFeedbackInterval'] = undefined;
  /**
   * Hostname or IP address to which events should be sent
   * @member {module:model/SettingValue} platformSettingSystemEventForwardingSnmpAddress
   */
  exports.prototype['platformSettingSystemEventForwardingSnmpAddress'] = undefined;
  /**
   * SMTP mail server address (optionally include :port)
   * @member {module:model/SettingValue} platformSettingSmtpServerAddress
   */
  exports.prototype['platformSettingSmtpServerAddress'] = undefined;
  /**
   * Allow Tenants to configure independent Event Forwarding SIEM settings
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantConfigureSiemEnabled
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantConfigureSiemEnabled'] = undefined;
  /**
   * SMTP password
   * @member {module:model/SettingValue} platformSettingSmtpPassword
   */
  exports.prototype['platformSettingSmtpPassword'] = undefined;
  /**
   * AWS SNS Configuration
   * @member {module:model/SettingValue} platformSettingEventForwardingSnsConfigJson
   */
  exports.prototype['platformSettingEventForwardingSnsConfigJson'] = undefined;
  /**
   * Automatically delete Firewall Events older than
   * @member {module:model/SettingValue} firewallSettingRetainEventDuration
   */
  exports.prototype['firewallSettingRetainEventDuration'] = undefined;
  /**
   * Untested
   * @member {module:model/SettingValue} webReputationSettingEventRankRiskUntested
   */
  exports.prototype['webReputationSettingEventRankRiskUntested'] = undefined;
  /**
   * When accessing MDR server, use proxy:
   * @member {module:model/SettingValue} platformSettingManagedDetectResponseUseProxyEnabled
   */
  exports.prototype['platformSettingManagedDetectResponseUseProxyEnabled'] = undefined;
  /**
   * Secret Key - The Secret Key of an AWS User with access to the SNS Topic
   * @member {module:model/SettingValue} platformSettingEventForwardingSnsSecretKey
   */
  exports.prototype['platformSettingEventForwardingSnsSecretKey'] = undefined;
  /**
   * Logo Bytes
   * @member {module:model/SettingValue} platformSettingLogoBinaryImageImg
   */
  exports.prototype['platformSettingLogoBinaryImageImg'] = undefined;
  /**
   * Secret Key - The Secret Access Key of an AWS User used for the manager identity
   * @member {module:model/SettingValue} platformSettingAwsManagerIdentitySecretKey
   */
  exports.prototype['platformSettingAwsManagerIdentitySecretKey'] = undefined;
  /**
   * Highly Suspicious
   * @member {module:model/SettingValue} webReputationSettingEventRankRiskHighlySuspicious
   */
  exports.prototype['webReputationSettingEventRankRiskHighlySuspicious'] = undefined;
  /**
   * Status Monitoring API Enabled
   * @member {module:model/SettingValue} platformSettingApiStatusMonitoringEnabled
   */
  exports.prototype['platformSettingApiStatusMonitoringEnabled'] = undefined;
  /**
   * Text
   * @member {module:model/SettingValue} platformSettingSignInPageMessage
   */
  exports.prototype['platformSettingSignInPageMessage'] = undefined;
  /**
   * Send email when a user's password is about to expire
   * @member {module:model/SettingValue} platformSettingUserPasswordExpirySendEmailEnabled
   */
  exports.prototype['platformSettingUserPasswordExpirySendEmailEnabled'] = undefined;
  /**
   * Number of incorrect sign-in attempts allowed (before lock out)
   * @member {module:model/SettingValue} platformSettingUserSignInAttemptsAllowedNumber
   */
  exports.prototype['platformSettingUserSignInAttemptsAllowedNumber'] = undefined;
  /**
   * When accessing Deep Discovery Analyzer, use proxy:
   * @member {module:model/SettingValue} platformSettingDdanUseProxyEnabled
   */
  exports.prototype['platformSettingDdanUseProxyEnabled'] = undefined;
  /**
   * Allow Agent-Initiated Activation
   * @member {module:model/SettingValue} platformSettingAgentInitiatedActivationEnabled
   */
  exports.prototype['platformSettingAgentInitiatedActivationEnabled'] = undefined;
  /**
   * Show the \"Remember Account Name and Username\" option
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantConfigureRememberMeOptionEnabled
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantConfigureRememberMeOptionEnabled'] = undefined;
  /**
   * Maximum bandwidth:
   * @member {module:model/SettingValue} platformSettingSmartProtectionFeedbackBandwidthMaxKbytes
   */
  exports.prototype['platformSettingSmartProtectionFeedbackBandwidthMaxKbytes'] = undefined;
  /**
   * Packet Rejection
   * @member {module:model/SettingValue} firewallSettingEventRankSeverityPacketRejection
   */
  exports.prototype['firewallSettingEventRankSeverityPacketRejection'] = undefined;
  /**
   * Deep Security Manager (Software Updates, CSSS, News Updates, Product Registration and Licensing):
   * @member {module:model/SettingValue} platformSettingProxyManagerUpdateProxyId
   */
  exports.prototype['platformSettingProxyManagerUpdateProxyId'] = undefined;
  /**
   * Use default server settings
   * @member {module:model/SettingValue} platformSettingManagedDetectResponseUsePrimaryTenantSettingsEnabled
   */
  exports.prototype['platformSettingManagedDetectResponseUsePrimaryTenantSettingsEnabled'] = undefined;
  /**
   * Access Key - The Access Key of an AWS User with access to the SNS Topic
   * @member {module:model/SettingValue} platformSettingEventForwardingSnsAccessKey
   */
  exports.prototype['platformSettingEventForwardingSnsAccessKey'] = undefined;
  /**
   * Allow Agent to specify hostname
   * @member {module:model/SettingValue} platformSettingAgentInitiatedActivationSpecifyHostnameEnabled
   */
  exports.prototype['platformSettingAgentInitiatedActivationSpecifyHostnameEnabled'] = undefined;
  /**
   * Allow Tenants to add with Cloud Accounts
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantSyncWithCloudAccountEnabled
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantSyncWithCloudAccountEnabled'] = undefined;
  /**
   * Use default server settings
   * @member {module:model/SettingValue} platformSettingConnectedThreatDefensesUsePrimaryTenantServerSettingsEnabled
   */
  exports.prototype['platformSettingConnectedThreatDefensesUsePrimaryTenantServerSettingsEnabled'] = undefined;
  /**
   * Delete Agents that have been inactive for:
   * @member {module:model/SettingValue} platformSettingInactiveAgentCleanupDuration
   */
  exports.prototype['platformSettingInactiveAgentCleanupDuration'] = undefined;
  /**
   * If a computer with the same name already exists
   * @member {module:model/SettingValue} platformSettingAgentInitiatedActivationDuplicateHostnameMode
   */
  exports.prototype['platformSettingAgentInitiatedActivationDuplicateHostnameMode'] = undefined;
  /**
   * Manager Node for NSX communication
   * @member {module:model/SettingValue} platformSettingVmwareNsxManagerNode
   */
  exports.prototype['platformSettingVmwareNsxManagerNode'] = undefined;
  /**
   * Text
   * @member {module:model/SettingValue} platformSettingUserEnforceTermsAndConditionsTitle
   */
  exports.prototype['platformSettingUserEnforceTermsAndConditionsTitle'] = undefined;
  /**
   * Allow Tenants to add VMware vCenters
   * @member {module:model/SettingValue} platformSettingPrimaryTenantAllowTenantAddVmwareVcenterEnabled
   */
  exports.prototype['platformSettingPrimaryTenantAllowTenantAddVmwareVcenterEnabled'] = undefined;
  /**
   * Enable the automatic download of Security Updates on new Tenants
   * @member {module:model/SettingValue} platformSettingNewTenantDownloadSecurityUpdateEnabled
   */
  exports.prototype['platformSettingNewTenantDownloadSecurityUpdateEnabled'] = undefined;
  /**
   * Computer Identifier 3
   * @member {module:model/SettingValue} platformSettingTenantProtectionUsageMonitoringComputerId3
   */
  exports.prototype['platformSettingTenantProtectionUsageMonitoringComputerId3'] = undefined;
  /**
   * Reactivate unknown Agents
   * @member {module:model/SettingValue} platformSettingAgentInitiatedActivationReactivateUnknownEnabled
   */
  exports.prototype['platformSettingAgentInitiatedActivationReactivateUnknownEnabled'] = undefined;
  /**
   * Computer Identifier 2
   * @member {module:model/SettingValue} platformSettingTenantProtectionUsageMonitoringComputerId2
   */
  exports.prototype['platformSettingTenantProtectionUsageMonitoringComputerId2'] = undefined;
  /**
   * Policy to assign (if Policy not assigned by activation script):
   * @member {module:model/SettingValue} platformSettingAgentInitiatedActivationPolicyId
   */
  exports.prototype['platformSettingAgentInitiatedActivationPolicyId'] = undefined;
  /**
   * Computer Identifier 1
   * @member {module:model/SettingValue} platformSettingTenantProtectionUsageMonitoringComputerId1
   */
  exports.prototype['platformSettingTenantProtectionUsageMonitoringComputerId1'] = undefined;
  /**
   * Number of older software versions to keep per platform
   * @member {module:model/SettingValue} platformSettingRetainAgentInstallersPerPlatformMax
   */
  exports.prototype['platformSettingRetainAgentInstallersPerPlatformMax'] = undefined;
  /**
   * Serve application control rulesets from relays
   * @member {module:model/SettingValue} applicationControlSettingServeRulesetsFromRelaysEnabled
   */
  exports.prototype['applicationControlSettingServeRulesetsFromRelaysEnabled'] = undefined;
  /**
   * High
   * @member {module:model/SettingValue} integrityMonitoringSettingEventRankSeverityHigh
   */
  exports.prototype['integrityMonitoringSettingEventRankSeverityHigh'] = undefined;
  /**
   * Automatically delete inactive identity provider users after (days)
   * @member {module:model/SettingValue} platformSettingSamlRetainInactiveExternalAdministratorsDuration
   */
  exports.prototype['platformSettingSamlRetainInactiveExternalAdministratorsDuration'] = undefined;
  /**
   * Automatically delete Intrusion Prevention Events older than
   * @member {module:model/SettingValue} intrusionPreventionSettingRetainEventDuration
   */
  exports.prototype['intrusionPreventionSettingRetainEventDuration'] = undefined;
  /**
   * Report only
   * @member {module:model/SettingValue} platformSettingHttpPublicKeyPinPolicyReportOnlyEnabled
   */
  exports.prototype['platformSettingHttpPublicKeyPinPolicyReportOnlyEnabled'] = undefined;
  /**
   * Service Name
   * @member {module:model/SettingValue} platformSettingSamlServiceProviderName
   */
  exports.prototype['platformSettingSamlServiceProviderName'] = undefined;
  /**
   * URL for testing Internet Connectivity Status
   * @member {module:model/SettingValue} firewallSettingInternetConnectivityTestUrl
   */
  exports.prototype['firewallSettingInternetConnectivityTestUrl'] = undefined;
  /**
   * Warn when the Deep Security Manager SAML Service Provider certificate will expire within (days)
   * @member {module:model/SettingValue} platformSettingSamlServiceProviderCertificateExpiryWarningDays
   */
  exports.prototype['platformSettingSamlServiceProviderCertificateExpiryWarningDays'] = undefined;
  /**
   * Primary Security Update Proxy used by Agents, Appliances, and Relays:
   * @member {module:model/SettingValue} platformSettingProxyAgentUpdateProxyId
   */
  exports.prototype['platformSettingProxyAgentUpdateProxyId'] = undefined;
  /**
   * Enable automatic file submission
   * @member {module:model/SettingValue} platformSettingDdanAutoSubmissionEnabled
   */
  exports.prototype['platformSettingDdanAutoSubmissionEnabled'] = undefined;
  /**
   * API Key
   * @member {module:model/SettingValue} platformSettingDdanManualSourceApiKey
   */
  exports.prototype['platformSettingDdanManualSourceApiKey'] = undefined;
  /**
   * Entity ID
   * @member {module:model/SettingValue} platformSettingSamlServiceProviderEntityId
   */
  exports.prototype['platformSettingSamlServiceProviderEntityId'] = undefined;
  /**
   * Error
   * @member {module:model/SettingValue} intrusionPreventionSettingEventRankSeverityFilterError
   */
  exports.prototype['intrusionPreventionSettingEventRankSeverityFilterError'] = undefined;
  /**
   * Automatically upgrade agents on activation
   * @member {module:model/SettingValue} platformSettingUpgradeOnActivationEnabled
   */
  exports.prototype['platformSettingUpgradeOnActivationEnabled'] = undefined;
  /**
   * High
   * @member {module:model/SettingValue} intrusionPreventionSettingEventRankSeverityFilterHigh
   */
  exports.prototype['intrusionPreventionSettingEventRankSeverityFilterHigh'] = undefined;
  /**
   * Low
   * @member {module:model/SettingValue} integrityMonitoringSettingEventRankSeverityLow
   */
  exports.prototype['integrityMonitoringSettingEventRankSeverityLow'] = undefined;



  return exports;
}));



