/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.0.466
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.VmwareVMVirtualMachineSummary = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The VmwareVMVirtualMachineSummary model module.
   * @module model/VmwareVMVirtualMachineSummary
   * @version 12.0.466
   */

  /**
   * Constructs a new <code>VmwareVMVirtualMachineSummary</code>.
   * Details of a VMWare virtual machine.
   * @alias module:model/VmwareVMVirtualMachineSummary
   * @class
   */
  var exports = function() {
    var _this = this;












  };

  /**
   * Constructs a <code>VmwareVMVirtualMachineSummary</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/VmwareVMVirtualMachineSummary} obj Optional instance to populate.
   * @return {module:model/VmwareVMVirtualMachineSummary} The populated <code>VmwareVMVirtualMachineSummary</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('operatingSystem')) {
        obj['operatingSystem'] = ApiClient.convertToType(data['operatingSystem'], 'String');
      }
      if (data.hasOwnProperty('memory')) {
        obj['memory'] = ApiClient.convertToType(data['memory'], 'String');
      }
      if (data.hasOwnProperty('vmwareTools')) {
        obj['vmwareTools'] = ApiClient.convertToType(data['vmwareTools'], 'String');
      }
      if (data.hasOwnProperty('biosUUID')) {
        obj['biosUUID'] = ApiClient.convertToType(data['biosUUID'], 'String');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
      if (data.hasOwnProperty('notes')) {
        obj['notes'] = ApiClient.convertToType(data['notes'], ['String']);
      }
      if (data.hasOwnProperty('CPU')) {
        obj['CPU'] = ApiClient.convertToType(data['CPU'], 'String');
      }
      if (data.hasOwnProperty('vCenterUUID')) {
        obj['vCenterUUID'] = ApiClient.convertToType(data['vCenterUUID'], 'String');
      }
      if (data.hasOwnProperty('NSXSecurityGroups')) {
        obj['NSXSecurityGroups'] = ApiClient.convertToType(data['NSXSecurityGroups'], ['String']);
      }
      if (data.hasOwnProperty('IPAddress')) {
        obj['IPAddress'] = ApiClient.convertToType(data['IPAddress'], 'String');
      }
      if (data.hasOwnProperty('DNSName')) {
        obj['DNSName'] = ApiClient.convertToType(data['DNSName'], 'String');
      }
    }
    return obj;
  }

  /**
   * Operating system, for example: \"Microsoft Windows Server 2012 (64-bit)\". Searchable as String.
   * @member {String} operatingSystem
   */
  exports.prototype['operatingSystem'] = undefined;
  /**
   * Memory allocation, for example: \"12,288 MB\".
   * @member {String} memory
   */
  exports.prototype['memory'] = undefined;
  /**
   * VMware tools status, for example: \"OK\".
   * @member {String} vmwareTools
   */
  exports.prototype['vmwareTools'] = undefined;
  /**
   * BIOS UUID, for example: \"421e1137-5c49-56e4-246d-9bf7637e69f5\". Searchable as String.
   * @member {String} biosUUID
   */
  exports.prototype['biosUUID'] = undefined;
  /**
   * Power state, for example: \"Powered On\".
   * @member {String} state
   */
  exports.prototype['state'] = undefined;
  /**
   * Notes associated with the VM.
   * @member {Array.<String>} notes
   */
  exports.prototype['notes'] = undefined;
  /**
   * Number and type of CPUs, for example: \"4 vCPU\". Searchable as Numeric.
   * @member {String} CPU
   */
  exports.prototype['CPU'] = undefined;
  /**
   * @member {String} vCenterUUID
   */
  exports.prototype['vCenterUUID'] = undefined;
  /**
   * @member {Array.<String>} NSXSecurityGroups
   */
  exports.prototype['NSXSecurityGroups'] = undefined;
  /**
   * @member {String} IPAddress
   */
  exports.prototype['IPAddress'] = undefined;
  /**
   * @member {String} DNSName
   */
  exports.prototype['DNSName'] = undefined;



  return exports;
}));



