/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.0.466
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.WeeklyScheduleParameters = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The WeeklyScheduleParameters model module.
   * @module model/WeeklyScheduleParameters
   * @version 12.0.466
   */

  /**
   * Constructs a new <code>WeeklyScheduleParameters</code>.
   * Details for the weekly schedule of a scheduled task.
   * @alias module:model/WeeklyScheduleParameters
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>WeeklyScheduleParameters</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/WeeklyScheduleParameters} obj Optional instance to populate.
   * @return {module:model/WeeklyScheduleParameters} The populated <code>WeeklyScheduleParameters</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('startTime')) {
        obj['startTime'] = ApiClient.convertToType(data['startTime'], 'Number');
      }
      if (data.hasOwnProperty('interval')) {
        obj['interval'] = ApiClient.convertToType(data['interval'], 'Number');
      }
      if (data.hasOwnProperty('days')) {
        obj['days'] = ApiClient.convertToType(data['days'], ['String']);
      }
    }
    return obj;
  }

  /**
   * Date/Time when the task should run.
   * @member {Number} startTime
   */
  exports.prototype['startTime'] = undefined;
  /**
   * Number of weeks between recurrences.
   * @member {Number} interval
   */
  exports.prototype['interval'] = undefined;
  /**
   * Days of the week when the scheduled task will run.
   * @member {Array.<module:model/WeeklyScheduleParameters.DaysEnum>} days
   */
  exports.prototype['days'] = undefined;


  /**
   * Allowed values for the <code>days</code> property.
   * @enum {String}
   * @readonly
   */
  exports.DaysEnum = {
    /**
     * value: "sunday"
     * @const
     */
    "sunday": "sunday",
    /**
     * value: "monday"
     * @const
     */
    "monday": "monday",
    /**
     * value: "tuesday"
     * @const
     */
    "tuesday": "tuesday",
    /**
     * value: "wednesday"
     * @const
     */
    "wednesday": "wednesday",
    /**
     * value: "thursday"
     * @const
     */
    "thursday": "thursday",
    /**
     * value: "friday"
     * @const
     */
    "friday": "friday",
    /**
     * value: "saturday"
     * @const
     */
    "saturday": "saturday"  };


  return exports;
}));



